'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\textbox.bi'

'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\multline.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\itemlist.bi'

'$INCLUDE: 'srcs\chat.str'

DECLARE SUB Net.DownloadPageSessionNoScreen (url AS STRING, OutputFile AS STRING, PostData() AS STRING)
DECLARE SUB SendMessage (message AS STRING)
DECLARE SUB UpdateMessage ()
DECLARE SUB UpdateUserList ()


'$DYNAMIC

IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	GUI.Init
	MouseSHow
	Alert (txtAlertNonetwork)
	app.Exit
END IF

DIM SHARED SessionID AS STRING
SessionID = RegRead("Live:SessionID")
IF SessionID = "" THEN
	App.Exec ("bin\login.exe bin\chat.exe")
END IF

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED UserData(1 TO 1) AS ListItem
DIM SHARED UserLIst AS ItemList
DIM SHARED NbrUser AS INTEGER
DIM ChatTxtBox AS MultiLine
DIM SHARED chattext AS STRING
wx = 580
wy = 350
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
DIM SHARED PostData(1 TO 3) AS STRING
DIM SHARED SelectedTarget AS STRING
DIM SHARED InputTxt AS TextBox
DIM SHARED SendBtn AS button

Init.ItemLIst UserLIst, wx1 + 5, wy1 + 25, 1, 30
UserLIst.MaxWidth = 15
UserLIst.MinWIdth = 15
Init.MultiLine ChatTxtBox, wx1 + 155, wy1 + 5, 50, 40
Init.TextBox InputTxt, wx1 + 155, wy2 - 17, 40
Initx.Button SendBtn, "Send", wx2 - 40, wy2 - 17, wx2 - 5, wy2 - 5
App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuLogout)
App.AddMenuItem (txtMenuExit)

GUI.Init
App.DrawGui

GOSUB Redraw
MouseSHow
t = TIMER
DO
	IF t + 10 < TIMER THEN
		GOSUB Redraw
		MouseSHow
	END IF
	IF NbrUser > 0 THEN
		Manage.ItemList UserLIst, UserData()
		IF UserLIst.SelectionChanged THEN
			SelectedTarget = LTRIM$(RTRIM$(UserLIst.SelectedText))
			GOSUB Redraw
			MouseSHow
		END IF
	END IF
	IF SelectedTarget <> "" THEN
		Manage.TextBox InputTxt
		IF InputTxt.textlen > 0 THEN
			IF Click.Button(SendBtn) OR InputTxt.TextChanged THEN
				GOSUB SendMsg
				MouseSHow
			END IF
		END IF
	END IF
	App.Manage
	SELECT CASE SelectedMenu
		CASE txtMenuExit:
			app.Exit
		CASE txtMenuLogout:
		       PostData(1) = ""
		       Net.DownloadPageSession ServerAdress + "/logout.php", "out.tmp", PostData()
		       fic = FREEFILE
		       KILL "out.tmp"
		       RegWrite "Live:SessionID", ""
		       App.Exec ("bin\login.exe bin\chat.exe")
	END SELECT
LOOP

Redraw:
	num$ = "chatdw"
	SaveScreen num$
	SCREEN 0
	WIDTH 80, 25
	UpdateUserList
	IF SelectedTarget <> "" THEN
	  UpdateMessage
	END IF
	SCREEN 12
	RestoreScreen num$
	Draw.Frame wx1, wy1, wx2, wy2
	Draw.Window wx1, wy1 - 15, wx1 + 135, wy2, txtBuddylistTitle
	Draw.Window wx1 + 150, wy1 - 15, wx2, wy2, txtConvTitle
       
	IF NbrUser > 0 THEN Draw.ItemList UserLIst, UserData()
	IF SelectedTarget <> "" THEN
		Draw.MUltiLIne ChatTxtBox, chattext
		Draw.TextBox InputTxt
		Draw.Button SendBtn
	END IF
	t = TIMER
RETURN


SendMsg:
	num$ = "chatmsg"
	SaveScreen num$
	SCREEN 0
	WIDTH 80, 25
	SendMessage (LEFT$(InputTxt.text, InputTxt.textlen))
	SCREEN 12
	RestoreScreen num$
	InputTxt.text = ""
	InputTxt.textlen = 0
	Draw.MUltiLIne ChatTxtBox, chattext
	Draw.TextBox InputTxt
	t = TIMER
RETURN

REM $STATIC
SUB SendMessage (message AS STRING)
	PostData(1) = "target=" + SelectedTarget
	PostData(2) = "action=sendmsg"
	PostData(3) = "message=" + StrEncode(message)
      
	Net.DownloadPageSessionNoScreen ServerAdress + "/chatmsg.php", "out.tmp", PostData()
	fic = FREEFILE
	chattext = ""
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, NbrLIne
		FOR i = 1 TO NbrLIne
			LINE INPUT #fic, ligne$
	       
		tpseudo$ = LEFT$(ligne$, INSTR(ligne$, " ") - 1)
		ttext$ = MID$(ligne$, INSTR(ligne$, " "))
		newline$ = CHR$(27) + CHR$(1) + CHR$(9) + tpseudo$ + CHR$(27) + CHR$(1) + CHR$(0) + CHR$(13) + CHR$(10) + ttext$
		IF i > 1 THEN newline$ = CHR$(13) + CHR$(10) + newline$
		chattext = chattext + newline$
		NEXT i
	CLOSE fic
	KILL "out.tmp"

END SUB

SUB UpdateMessage
	PostData(1) = "target=" + SelectedTarget
	PostData(2) = "action=getmsg"
	PostData(3) = ""
       
	Net.DownloadPageSessionNoScreen ServerAdress + "/chatmsg.php", "out.tmp", PostData()
	
	fic = FREEFILE
	chattext = ""
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, NbrLIne
		FOR i = 1 TO NbrLIne
		      LINE INPUT #fic, ligne$
		
		tpseudo$ = LEFT$(ligne$, INSTR(ligne$, " ") - 1)
		ttext$ = MID$(ligne$, INSTR(ligne$, " "))
		newline$ = CHR$(27) + CHR$(1) + CHR$(9) + tpseudo$ + CHR$(27) + CHR$(1) + CHR$(0) + CHR$(13) + CHR$(10) + ttext$
		IF i > 1 THEN newline$ = CHR$(13) + CHR$(10) + newline$
		chattext = chattext + newline$
		NEXT i
	CLOSE fic
	KILL "out.tmp"


END SUB

SUB UpdateUserList
		       PostData(1) = ""
		       Net.DownloadPageSessionNoScreen ServerAdress + "/chatuser.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, NbrUser
				IF NbrUser > 0 THEN
					REDIM UserData(1 TO NbrUser)  AS ListItem
					FOR i = 1 TO NbrUser
						INPUT #fic, UserData(i).text
						UserData(i).selected = 0
					NEXT i
					
				ELSE
					REDIM UserData(1 TO 1) AS ListItem
				END IF
		       CLOSE fic
		       KILL "out.tmp"
END SUB

