DECLARE SUB ParseDate (DateString AS STRING)
DECLARE SUB Draw.Appointments ()
DECLARE SUB Manage.AppointMents ()
DECLARE SUB SortRDV (rdvs() AS ANY)
DECLARE SUB Load.Rdv ()
DECLARE FUNCTION CmpTime% (Hour1%, Minuts1%, Hour2%, Minuts2%)
DECLARE FUNCTION CmpDate% (day1%, month1%, year1%, day2%, month2%, year2%)
DECLARE SUB Manage.panel ()
DECLARE SUB Draw.Status (num AS INTEGER)
DECLARE SUB Load.Panel ()
DECLARE SUB Draw.Panel ()
DECLARE SUB Draw.StatusBar (text AS STRING)
DECLARE SUB Focus.Icon (num AS INTEGER)
DECLARE SUB DrawIcons (num AS INTEGER)
DECLARE SUB ManageIcons ()
DECLARE SUB LoadIcons ()

'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\itemlist.bi'

'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'

'$INCLUDE: 'srcs\desktop.str'

TYPE RDV
	Day AS INTEGER
	Month AS INTEGER
	Year AS INTEGER
	Hour AS INTEGER
	Minuts AS INTEGER
	title AS STRING * 100
	Adress AS STRING * 100
	DurationHour AS INTEGER
	DurationMinut AS INTEGER
END TYPE

TYPE AppIcon
	IconFIle AS STRING * 25
	AppFile AS STRING * 25
	Descr AS STRING * 50
END TYPE

'$DYNAMIC
'ON ERROR GOTO catch

DIM SHARED RDVData(1 TO 1) AS ListItem
DIM SHARED MaxRDV AS INTEGER
DIM SHARED SelectedDateStr AS STRING
DIM SHARED OpenRDV AS button
DIM SHARED rep AS INTEGER
DIM SHARED NbrRdv AS INTEGER
DIM SHARED NbrGroup AS INTEGER
DIM SHARED NbrIcons(1) AS INTEGER
DIM SHARED icons(1, 1) AS AppIcon
DIM SHARED GroupNames(1) AS STRING
DIM SHARED SelectedGroup AS INTEGER
DIM SHARED RdvList AS ItemList
DIM SHARED MonthStr(1 TO 12) AS STRING * 4
MonthStr(1) = txtMonthJan
MonthStr(2) = txtMonthFeb
MonthStr(3) = txtMonthMar
MonthStr(4) = txtMonthApr
MonthStr(5) = txtMonthMay
MonthStr(6) = txtMonthJun
MonthStr(7) = txtMonthJul
MonthStr(8) = txtMonthAug
MonthStr(9) = txtMonthSep
MonthStr(10) = txtMonthOct
MonthStr(11) = txtMonthNov
MonthStr(12) = txtMonthDec

App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuColors)
App.AddMenuItem (txtMenuIcons)
App.AddMenuItem (txtMenuRegedit)
App.AddMenuItem (txtMenuShell)
IF VAL(RegRead("Network:Enabled")) = 1 THEN
IF RegRead("Live:SessionID") = "" THEN
	App.AddMenuItem (txtMenuLivelogin)
ELSE
	App.AddMenuItem (txtMenuLivelogout)
END IF
END IF
App.AddMenuItem (txtMenuScrsaver)
App.AddMenuItem (txtMenuExit)
SHelfColor = VAL(RegRead("desktop:ShelfColor"))
Load.Rdv
GUI.Init
App.DrawGui
Load.Panel
Draw.Panel
Draw.Appointments
MouseShow

DO
	SelectedMenu = ""
	App.Manage
	Manage.panel
	Manage.AppointMents
	SELECT CASE SelectedMenu
		CASE txtMenuIcons
			CHAIN "bin\appmgr.exe"
		CASE txtMenuRegedit
			CHAIN "bin\regedit.exe"
		CASE txtMenuShell:
			CHAIN "bin\dosshell.exe"
		CASE txtMenuColors:
			CHAIN "bin\colors.exe"
		CASE txtMenuExit
			EXIT DO
		CASE txtMenuLivelogin
			App.Exec ("bin\login.exe bin\desktop")
		CASE txtMenuLivelogout
			App.Exec ("bin\logout.exe bin\desktop")
		CASE txtMenuScrsaver
			SaveScreen ("desktop")
			SHELL "bin\scrsave.exe"
			RestoreScreen ("desktop")
	END SELECT
LOOP
SCREEN 0
WIDTH 80, 25
END



catch:
	rep = 0
	RESUME NEXT

REM $STATIC
FUNCTION CmpDate% (day1%, month1%, year1%, day2%, month2%, year2%)
	IF year1% < year2% THEN CmpDate = -1: EXIT FUNCTION
	IF year1% > year2% THEN CmpDate = 1: EXIT FUNCTION
	IF month1% < month2% THEN CmpDate = -1: EXIT FUNCTION
	IF month1% > month2% THEN CmpDate = 1: EXIT FUNCTION
	IF day1% < day2% THEN CmpDate = -1: EXIT FUNCTION
	IF day1% > day2% THEN CmpDate = 1: EXIT FUNCTION
	CmpDate = 0
END FUNCTION

FUNCTION CmpTime% (Hour1%, Minuts1%, Hour2%, Minuts2%)
	IF Hour1% < Hour2% THEN CmpTime% = -1: EXIT FUNCTION
	IF Hour1% > Hour2% THEN CmpTime% = 1: EXIT FUNCTION
	IF Minuts1% < Minuts2% THEN CmpTime% = -1: EXIT FUNCTION
	IF Minuts1% > Minuts2% THEN CmpTime% = 1: EXIT FUNCTION
	CmpTime% = 0
END FUNCTION

SUB Draw.Appointments
	ax1% = 10
	ay1% = 30
	ax2% = 342
	ay2% = 180
	Draw.Window ax1%, ay1%, ax2%, ay2%, txtAptsTitle1 + STR$(NbrRdv) + txtAptsTitle2
	IF NbrRdv > 0 THEN
	Init.ItemLIst RdvList, ax1% + 4, ay1% + 30, 1, 8
	RdvList.MaxWidth = 40
	RdvList.MInWidth = 40
	Draw.ItemList RdvList, RDVData()
	Initx.Button OpenRDV, txtAptsShowseld, ax1% + 5, ay2% - 20, ax2% - 5, ay2% - 5
	Draw.Button OpenRDV
	ELSE
		Draw.Text txtAptsNothing, ax1% + 55, ay1% + 50, 12, BgColor
	END IF
END SUB

SUB Draw.Panel
       MouseHide

       Draw.Frame 0, 428, 639, 467
       
       xpos% = 0
      
       FOR i = 1 TO NbrGroup
	    t$ = GroupNames(i)
	    w% = LEN(t$) * 8 + 20
	    c% = ABS(SelectBgColor * (i = SelectedGroup)) + ABS(BgColor * (i <> SelectedGroup))
	    c2% = ABS(SelectTextColor * (i = SelectedGroup)) + ABS(TextCOlor * (i <> SelectedGroup))
	    Draw.Frame xpos%, 413, xpos% + w% - 1, 427
	    LINE (xpos% + 1, 414)-(xpos% + w% - 3, 425), c%, BF
	    Draw.Text t$, xpos% + 10, 416, c2%, -1
	    xpos% = xpos% + w%
       NEXT i
       IF SelectedGroup > 0 THEN
	FOR i = 1 TO NbrIcons(SelectedGroup)
		i$ = LTRIM$(RTRIM$(icons(SelectedGroup, i).IconFIle))
		x% = ((i - 1) * 40) + 5
		y% = 433
		ay% = y%
		ax% = x%
		Draw.Pic i$, x%, y%, 1
		IF SelectedGroup = 1 THEN
		 a$ = LTRIM$(RTRIM$(RegRead("System:Drive" + LTRIM$(RTRIM$(STR$(i))))))
		 a$ = UCASE$(a$)
		 FOR k = 0 TO 1
			FOR l = 0 TO 1
				 Draw.Text a$, ax% + 11 + k, ay% + 0 + l, TextCOlor, -1
			NEXT l
		 NEXT k
	       
		END IF
	NEXT i
       END IF
       Draw.Status 0
       MouseShow
END SUB

SUB Draw.Status (num AS INTEGER)
	MouseHide
       Draw.Frame 0, 468, 639, 479
       IF (num > 0) AND (SelectedGroup > 0) THEN
	Draw.Text LTRIM$(RTRIM$(icons(SelectedGroup, num).Descr)), 5, 470, TextCOlor, -1
       END IF
      MouseShow
 
END SUB

SUB Load.Panel
	NbrGroup = VAL(RegRead("Shelf:NbrGroup")) + 1

	IF NbrGroup > 9 THEN NbrGroup = 9
	REDIM GroupNames(1 TO NbrGroup + 1) AS STRING
	REDIM NbrIcons(1 TO NbrGroup + 1) AS INTEGER
	max = 0
		GroupNames(1) = txtDrivesTitle
		NbrIcons(1) = VAL(RegRead("System:NbrDrives"))

	FOR i = 2 TO NbrGroup + 1
		GroupNames(i) = RegRead("Shelf:GroupName" + CHR$((i - 1) + 48))
		NbrIcons(i) = VAL(RegRead("Shelf:NbrIcons" + CHR$((i - 1) + 48)))
		IF max < NbrIcons(i) THEN max = NbrIcons(i)
	NEXT i
	ERASE icons
	REDIM icons(1 TO NbrGroup + 1, 1 TO max + 1) AS AppIcon
	FOR j = 1 TO NbrIcons(1)
	a$ = LTRIM$(RTRIM$(RegRead("System:Drive" + LTRIM$(RTRIM$(STR$(j))))))
		icons(1, j).AppFile = "Bin\FMANAGER.EXE " + a$ + ":"
		icons(1, j).IconFIle = "Icons\hd.pic"
		icons(1, j).Descr = txtDrivesLocal + a$ + ":\"
	NEXT j
	FOR i = 2 TO NbrGroup + 1
		FOR j = 1 TO NbrIcons(i)
			reg$ = "Shelf:Group" + CHR$((i - 1) + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(j)))
			icons(i, j).AppFile = RegRead(reg$ + ":AppFile")
			icons(i, j).IconFIle = RegRead(reg$ + ":IconFile")
			icons(i, j).Descr = RegRead(reg$ + ":Descr")
		NEXT j
	NEXT i

	SelectedGroup = VAL(RegRead("Shelf:Selected"))
	IF SelectedGroup = 0 THEN SelectedGroup = 1
	IF SelectedGroup > NbrGroup THEN SelectedGroup = 0
END SUB

SUB Load.Rdv
	MaxRDV = VAL(RegRead("desktop:MaxAppointments"))
	IF MaxRDV = 0 THEN MaxRDV = 5
CMonth% = VAL(LEFT$(DATE$, 2))
CDay% = VAL(MID$(DATE$, 4, 2))
CYear% = VAL(RIGHT$(DATE$, 4))

	fic = FREEFILE
	DIM Entry AS RDV
	OPEN "system\planer.dat" FOR BINARY AS fic
	      NRdv = LOF(fic) \ LEN(Entry)
	      NbrRdv = 0
		FOR i = 1 TO NRdv
		    GET #fic, , Entry
		    CMP% = CmpDate(CDay%, CMonth%, CYear%, Entry.Day, Entry.Month, Entry.Year)
		    IF CMP% <= 0 THEN NbrRdv = NbrRdv + 1
		NEXT i
	CLOSE fic

	IF NbrRdv = 0 THEN
		
		EXIT SUB
	END IF
	DIM rdvs(1 TO NbrRdv) AS RDV
	Index = 1
	OPEN "system\planer.dat" FOR BINARY AS fic
		FOR i = 1 TO NRdv
			GET #fic, , Entry
			CMP% = CmpDate(CDay%, CMonth%, CYear%, Entry.Day, Entry.Month, Entry.Year)
			IF CMP% <= 0 THEN
				rdvs(Index) = Entry
				Index = Index + 1
			END IF
		NEXT i
	CLOSE fic
	SortRDV rdvs()
	IF NbrRdv > MaxRDV THEN NbrRdv = MaxRDV
	REDIM RDVData(1 TO NbrRdv) AS ListItem
	FOR i = 1 TO NbrRdv
	    h$ = LTRIM$(STR$(rdvs(i).Hour)): IF LEN(h$) < 2 THEN h$ = "0" + h$
	    m$ = LTRIM$(STR$(rdvs(i).Minuts)): IF LEN(m$) < 2 THEN m$ = "0" + m$
	    d$ = LTRIM$(STR$(rdvs(i).Day)): IF LEN(d$) < 2 THEN d$ = "0" + d$
	    a$ = d$ + " " + MonthStr(rdvs(i).Month) + STR$(rdvs(i).Year)
	    b$ = h$ + ":" + m$
	    c$ = LTRIM$(RTRIM$(rdvs(i).title))
	    t$ = a$ + " - " + b$ + " - " + c$
	    RDVData(i).text = t$
	NEXT i
END SUB

SUB Manage.AppointMents
	
	IF NbrRdv > 0 THEN
		Manage.ItemList RdvList, RDVData()
		IF SelectedDateStr <> "" THEN
			IF Click.Button(OpenRDV) THEN
				App.Exec ("bin\planner.exe " + SelectedDateStr)
			END IF
		END IF
		IF RdvList.SelectionCHanged THEN ParseDate LTRIM$(RTRIM$(RdvList.SelectedText))

	END IF
END SUB

SUB Manage.panel
       xpos% = 0
       FOR i = 1 TO NbrGroup
	    t$ = GroupNames(i)
	    w% = LEN(t$) * 8 + 20
	    IF MouseZOne(xpos%, 415, xpos% + w% - 1, 429) AND MouseClicLeft THEN
		DO: LOOP UNTIL NOT (MouseZOne(xpos%, 420, xpos% + w% - 1, 429) AND MouseClicLeft)
		IF MouseZOne(xpos%, 415, xpos% + w% - 1, 429) THEN
			SelectedGroup = i
			Draw.Panel
			EXIT SUB
		END IF
	    END IF
	    xpos% = xpos% + w%
       NEXT i
       IF SelectedGroup > 0 THEN
	FOR i = 1 TO NbrIcons(SelectedGroup)
		x1% = ((i - 1) * 40) + 5
		y1% = 435
		x2% = x1% + 29
		y2% = y1% + 29
		IF MouseZOne(x1%, y1%, x2%, y2%) THEN
			Draw.Status (i)
			DO
				IF MouseClicLeft THEN
					DO: LOOP UNTIL NOT (MouseClicLeft AND MouseZOne(x1%, y1%, x2%, y2%))
					IF MouseZOne(x1%, y1%, x2%, y2%) THEN
						RegWrite "Shelf:Selected", STR$(SelectedGroup)
						App.Exec icons(SelectedGroup, i).AppFile
					END IF
				END IF
			LOOP UNTIL NOT MouseZOne(x1%, y1%, x2%, y2%)
			Draw.Status (0)
		END IF
	NEXT i
       END IF

END SUB

SUB ParseDate (DateString AS STRING)
	SelectedDateStr = ""
	ok = 0
	SelectedMonth = 0
	SelectedDay = 0
	SelectedYear = 0
	FOR i = 1 TO 12
		IF INSTR(DateString, MonthStr(i)) > 0 THEN SelectedMonth = i
	NEXT i
	IF SelectedMonth > 0 THEN
		SelectedDay = VAL(LEFT$(DateString, 2))
		SelectedYear = VAL(MID$(DateString, 9, 4))
		SelectedDateStr = RTRIM$(STR$(SelectedDay)) + CHR$(13) + RTRIM$(STR$(SelectedMonth)) + CHR$(13) + RTRIM$(STR$(SelectedYear)) + CHR$(13)
	END IF
'        PRINT SelectedDateStr
END SUB

SUB SortRDV (rdvs() AS RDV)
     NoChange = 0
     DO
	NoChange = -1
	FOR j = LBOUND(rdvs) TO UBOUND(rdvs) - 1
		CMP% = CmpDate(rdvs(j).Day, rdvs(j).Month, rdvs(j).Year, rdvs(j + 1).Day, rdvs(j + 1).Month, rdvs(j + 1).Year)
		IF CMP% > 0 THEN SWAP rdvs(j), rdvs(j + 1): NoChange = 0
		IF CMP% = 0 THEN
			CMP% = CmpTime(rdvs(j).Hour, rdvs(j).Minuts, rdvs(j + 1).Hour, rdvs(j + 1).Minuts)
			IF CMP% > 0 THEN SWAP rdvs(j), rdvs(j + 1): NoChange = 0
		END IF
	NEXT j
     LOOP WHILE NoChange = 0
END SUB

