'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'srcs\fshare.str'
DECLARE SUB UploadFile (filename AS STRING, newfilename AS STRING, target AS STRING)
DECLARE SUB UpdateFiles ()
DECLARE SUB SendMessage (message AS STRING)
DECLARE SUB UpdateMessage ()
DECLARE SUB UpdateUserList ()


'$DYNAMIC

IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	GUI.Init
	MouseShow
	Alert (txtAlertNonetwork)
	app.Exit
END IF


DIM SHARED SessionID AS STRING
DIM SHARED FolderID AS STRING
SessionID = RegRead("Live:SessionID")
IF SessionID = "" THEN
	App.Exec ("bin\login.exe bin\fshare.exe")
END IF

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED UserData(1 TO 1) AS LIstItem
DIM SHARED UserList AS ItemList
DIM SHARED FileData(1 TO 1) AS LIstItem
DIM SHARED FIleLIst AS ItemList
DIM SHARED NbrUser AS INTEGER
DIM SHARED NbrFiles AS INTEGER
wx = 550
wy = 300
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
DIM SHARED PostData(1 TO 3) AS STRING
DIM SHARED SelectedTarget AS STRING
DIM SHARED DownloadButton AS Button
DIM SHARED UploadButton AS Button
DIM SHARED selectedFile AS STRING
Init.ItemLIst UserList, wx1 + 5, wy1 + 25, 1, 25
Init.ItemLIst FIleLIst, wx1 + 140, wy1 + 25, 4, 25
Initx.Button DownloadButton, txtButtonDownload, wx2 - 150, wy2 - 15, wx2 - 80, wy2 - 5
Initx.Button UploadButton, txtButtonUpload, wx2 - 75, wy2 - 15, wx2 - 5, wy2 - 5
UserList.MinWIdth = 15
UserList.MaxWidth = 15
FIleLIst.MinWIdth = 12
FIleLIst.MaxWidth = 12
App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuLogout)
App.AddMenuItem (txtMenuExit)

GUI.Init
App.DrawGui
GOSUB Redraw
MouseShow
DO
	
	Manage.ItemList UserList, UserData()
	IF UserList.SelectionChanged THEN
		SelectedTarget = LTRIM$(RTRIM$(UserList.SelectedText))
		selectedFile = ""
		GOSUB Redraw
	END IF

	IF SelectedTarget <> "" THEN
		Manage.ItemList FIleLIst, FileData()
		IF FIleLIst.SelectionChanged THEN
			selectedFile = LTRIM$(RTRIM$(FIleLIst.SelectedText))
		END IF
		IF Click.Button(UploadButton) THEN
			fichier$ = FileSelect("open", CurrentDir, "")
			IF fichier$ <> "" THEN
			   finame$ = fichier$
			   t = INSTR(finame$, "\")
				WHILE t > 0
					finame$ = MID$(finame$, INSTR(finame$, "\") + 1)
					t = INSTR(finame$, "\")
				WEND
			   UploadFile fichier$, finame$, SelectedTarget
			   GOSUB Redraw
			END IF
		END IF
		IF selectedFile <> "" THEN
			IF Click.Button(DownloadButton) THEN
			   fichier$ = FileSelect("Save", CurrentDir, "")
			   IF fichier$ <> "" THEN
				IF LCASE$(LEFT$(fichier$, LEN(CurrentDir))) = LCASE$(CurrentDir) THEN fichier$ = MID$(fichier$, LEN(CurrentDir) + 2)
				PostData(1) = ""
				url$ = ServerAdress + "/files/" + FolderID + "/" + selectedFile
				Net.DownloadPage url$, fichier$, PostData()
			   END IF
			END IF
		END IF
	END IF
	App.Manage
	SELECT CASE SelectedMenu
		CASE txtMenuExit:
			app.Exit
		CASE txtMenuLogout:
		       PostData(1) = ""
		       Net.DownloadPageSession ServerAdress + "/logout.php", "out.tmp", PostData()
		       fic = FREEFILE
		       KILL "out.tmp"
		       RegWrite "Live:SessionID", ""
		       App.Exec ("bin\login.exe bin\fshare.exe")
	END SELECT
LOOP

Redraw:
	Draw.Window wx1, wy1 - 15, wx2, wy2, txtFilesTitle
	UpdateUserList
	Draw.ItemList UserList, UserData()
	IF SelectedTarget <> "" THEN
		UpdateFiles
		IF NbrFiles > 0 THEN
			Draw.ItemList FIleLIst, FileData()
			Draw.Button DownloadButton
		END IF
		Draw.Button UploadButton
	      
	END IF
	MouseShow
RETURN

REM $STATIC
SUB UpdateFiles
	PostData(1) = "action=filelist"
	PostData(2) = "target=" + SelectedTarget
	Net.DownloadPageSession ServerAdress + "/fshare.php", "out.tmp", PostData()

	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, FolderID
		IF FolderID <> "0" THEN
			INPUT #fic, NbrFiles


		ELSE
			CLOSE fic
			MouseShow
			Alert (txtAlertExpsession)
			RegWrite "Live:SessionID", ""
			
			App.Exec "bin\login.exe bin\fshare.exe"

		END IF
		IF NbrFiles > 0 THEN
			REDIM FileData(1 TO NbrFiles) AS LIstItem
			FOR i = 1 TO NbrFiles
				INPUT #fic, FileData(i).Text
				FileData(i).Selected = 0
			NEXT i
		ELSE
			REDIM FileData(1 TO 1) AS LIstItem
		END IF
	CLOSE fic
	KILL "out.tmp"
END SUB

SUB UpdateUserList
		       PostData(1) = ""
		       Net.DownloadPageSession ServerAdress + "/liveuser.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, NbrUser
				IF NbrUser > 0 THEN
					REDIM UserData(1 TO NbrUser)  AS LIstItem
					FOR i = 1 TO NbrUser
						INPUT #fic, UserData(i).Text
						UserData(i).Selected = 0
					NEXT i
					
				ELSE
					REDIM UserData(1 TO 1) AS LIstItem
				END IF
		       CLOSE fic
		       KILL "out.tmp"
END SUB

SUB UploadFile (filename AS STRING, newfilename AS STRING, target AS STRING)
       fic = FREEFILE
       num$ = LTRIM$(RTRIM$(STR$(INT(TIMER))))
      
      
	retriever$ = "bin\curl.exe -K url.txt -o out.tmp -F " + CHR$(34) + "file=@" + filename + CHR$(34)
	OPEN "url.txt" FOR OUTPUT AS fic
		PRINT #fic, "url "; ServerAdress + "/fshare.php"
		PRINT #fic, "form " + "session=" + SessionID
		PRINT #fic, "form " + "target=" + target
		PRINT #fic, "form " + "action=sendfile"
		PRINT #fic, "form " + "filename=" + newfilename
	CLOSE fic
       
	OPEN "cmdline.bat" FOR OUTPUT AS fic
		PRINT #fic, retriever$
	CLOSE fic
       
	SaveScreen num$
	SCREEN 0
	WIDTH 80, 25
	SHELL "cmdline.bat"
	KILL "cmdline.bat"
	SCREEN 12
	RestoreScreen num$
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, FolderID
		INPUT #fic, NbrFiles
		IF NbrFiles > 0 THEN
			REDIM FileData(1 TO NbrFiles) AS LIstItem
			FOR i = 1 TO NbrFiles
				INPUT #fic, FileData(i).Text
				FileData(i).Selected = 0
			NEXT i
		ELSE
			REDIM FileData(1 TO NbrFiles) AS LIstItem
		END IF
	CLOSE fic
	KILL "out.tmp"
END SUB

