'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\reg.bi'

'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\itemlist.bi'

'$INCLUDE: 'srcs\sfselect.str'

DECLARE SUB UploadFile (filename AS STRING, newfilename AS STRING, target AS STRING)
DECLARE SUB LoadFiles ()
DECLARE SUB LoadDirs ()

IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	Gui.Init
	MouseShow
	Alert (txtAlertNonetwork)
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
       
END IF


'$DYNAMIC

DIM SHARED PostData(1 TO 3) AS STRING
DIM SHARED SessionID AS STRING
DIM SHARED Folderid AS STRING
SessionID = RegRead("Live:SessionID")
IF SessionID = "" THEN
	
	Alert (txtAlertNotconnected)
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	END
END IF

Gui.Init

DIM SHARED mode AS STRING
DIM SHARED ext AS STRING
mode = opt$("mode")
ext = opt$("ext")

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED CurrDir AS STRING
DIM SHARED DirsList AS ItemList
DIM SHARED FilesList AS ItemList
DIM SHARED DirsData(1) AS ListItem
DIM SHARED FIlesData(1) AS ListItem
DIM SHARED OpenButton AS button
DIM SHARED CancelButton AS button
DIM SHARED NbrDir AS INTEGER
DIM SHARED NbrFIles AS INTEGER
DIM SHARED FileText AS TextBox
wx = 345
wy = 145
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
	Init.ItemLIst DirsList, wx1 + 5, wy1 + 17, 1, 9
	Init.ItemLIst FilesList, wx1 + 135, wy1 + 17, 2, 9
	DirsList.MaxWidth = 15
	DirsList.MinWIdth = 15
	FilesList.MaxWidth = 12
	FilesList.MinWIdth = 12
Initx.Button OpenButton, mode, wx2 - 140, wy2 - 17, wx2 - 75, wy2 - 5
Initx.Button CancelButton, "Cancel", wx2 - 70, wy2 - 17, wx2 - 5, wy2 - 5
Init.TextBox FileText, wx1 + 95, wy2 - 17, 12
debut:
LoadDirs
Draw.Window wx1, wy1 - 15, wx2, wy2, txtInstruction
Draw.ItemList DirsList, DirsData()
Draw.Button OpenButton
Draw.Button CancelButton
Draw.TextBox FileText
MouseShow
DO
     a$ = INKEY$
     ScreenCapture a$
     IF NbrDir > 0 THEN Manage.ItemList DirsList, DirsData()
     IF NbrFIles > 0 THEN Manage.ItemList FilesList, FIlesData()
     IF DirsList.SelectionChanged THEN GOSUB ChangeDIr
     IF mode = "SAVE" THEN Manage.TextBox FileText
     IF FilesList.SelectionChanged THEN
	FileText.text = LTRIM$(RTRIM$(FilesList.SelectedText))
	FileText.textlen = LEN(LTRIM$(RTRIM$(FilesList.SelectedText)))
	Draw.TextBox FileText
     END IF
     IF (Click.Button(OpenButton) OR a$ = CHR$(13)) THEN
	ok = -1
	SelectedFile$ = LTRIM$(RTRIM$(FileText.text))
	IF UCASE$(mode) = "SAVE" THEN
		FOR i = 1 TO NbrFIles
			IF LCASE$(LTRIM$(RTRIM$(FIlesData(i).text))) = LCASE$(LTRIM$(RTRIM$(FileText.text))) THEN
				ok = Confirm(txtOverwrite)
			END IF
		NEXT i
		'if its a document, we will save the wor (indoc.tmp) to the selected file
		IF ok THEN
			UploadFile "indoc.tmp", SelectedFile$, CurrDir
			KILL "indoc.tmp"
		END IF
	END IF
	IF LCASE$(mode) = "open" THEN
		'download the file to outdoc.tmp
		PostData(1) = ""
		url$ = ServerAdress + "files/" + Folderid + "/" + LTRIM$(RTRIM$(FileText.text))
		Net.DownloadPage url$, "outdoc.tmp", PostData()
	END IF
	IF ok THEN
		fic = FREEFILE
		OPEN "out.tmp" FOR OUTPUT AS fic
			PRINT #fic, 1
			IF LCASE$(mode) = "open" THEN PRINT #fic, "outdoc.tmp"
			IF LCASE$(mode) = "save" THEN PRINT #fic, "indoc.tmp"
		CLOSE fic
		EXIT DO
	END IF
     END IF
     IF Click.Button(CancelButton) OR a$ = CHR$(27) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	IF LCASE$(mode) = "save" THEN KILL "indoc.tmp"
	EXIT DO
     END IF
LOOP
END

ChangeDIr:
			CurrDir = LTRIM$(RTRIM$(DirsList.SelectedText))
			LoadFiles
			IF NbrFIles > 0 THEN
				Draw.ItemList FilesList, FIlesData()
			ELSE
				LINE (FilesList.x1, FilesList.y1)-(wx2 - 5, OpenButton.y1 - 1), BgColor, BF
			END IF
			RETURN
RETURN

REM $STATIC
SUB LoadDirs
		       PostData(1) = ""
		       Net.DownloadPageSession ServerAdress + "liveuser.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, NbrDir
				IF NbrDir > 0 THEN
					REDIM DirsData(1 TO NbrDir)  AS ListItem
					FOR i = 1 TO NbrDir
						INPUT #fic, DirsData(i).text
						DirsData(i).selected = 0
					NEXT i
				ELSE
					REDIM DirsData(1 TO 1) AS ListItem
				END IF
		       CLOSE fic
		       KILL "out.tmp"



END SUB

SUB LoadFiles
	PostData(1) = "action=filelist"
	PostData(2) = "target=" + CurrDir
	Net.DownloadPageSession ServerAdress + "fshare.php", "out.tmp", PostData()

	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, Folderid
		IF Folderid = "0" THEN
			CLOSE fic
			MouseShow
			Alert (txtAlertExpsession)
			RegWrite "Live:SessionID", ""
			OPEN "out.tmp" FOR OUTPUT AS fic
				PRINT #fic, 0
			CLOSE fic
			END
		END IF
		INPUT #fic, NbrFIles
		IF NbrFIles > 0 THEN
			REDIM FIlesData(1 TO NbrFIles) AS ListItem
			FOR i = 1 TO NbrFIles
				INPUT #fic, FIlesData(i).text
				FIlesData(i).selected = 0
			NEXT i
		ELSE
			REDIM FIlesData(1 TO 1) AS ListItem
		END IF
	CLOSE fic
	KILL "out.tmp"
	MouseShow
END SUB

SUB UploadFile (filename AS STRING, newfilename AS STRING, target AS STRING)
       fic = FREEFILE
       num$ = LTRIM$(RTRIM$(STR$(INT(TIMER))))
     
     
	retriever$ = "bin\curl.exe -K url.txt -o out.tmp -F " + CHR$(34) + "file=@" + filename + CHR$(34)
	OPEN "url.txt" FOR OUTPUT AS fic
		PRINT #fic, "url "; ServerAdress + "fshare.php"
		PRINT #fic, "form " + "session=" + SessionID
		PRINT #fic, "form " + "target=" + target
		PRINT #fic, "form " + "action=sendfile"
		PRINT #fic, "form " + "filename=" + newfilename
	CLOSE fic
      
	OPEN "cmdline.bat" FOR OUTPUT AS fic
		PRINT #fic, retriever$
	CLOSE fic
      
	SaveScreen num$
	SCREEN 0
	WIDTH 80, 25
	SHELL "cmdline.bat"
	KILL "cmdline.bat"
	SCREEN 12
	RestoreScreen num$
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, Folderid
		INPUT #fic, NbrFIles
		IF NbrFIles > 0 THEN
			REDIM FileData(1 TO NbrFIles) AS ListItem
			FOR i = 1 TO NbrFIles
				INPUT #fic, FileData(i).text
				FileData(i).selected = 0
			NEXT i
		ELSE
			REDIM FileData(1 TO NbrFIles) AS ListItem
		END IF
	CLOSE fic
	KILL "out.tmp"
	KILL "url.txt"
END SUB

