DECLARE SUB RegWrite (akey AS STRING, avalue AS STRING)
DECLARE SUB Draw.StatusBar (Text AS STRING)
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\cliczone.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'srcs\qmlview.str'

DECLARE SUB DownloadFile (url$)
DECLARE SUB Append.Download (url$, Texte$)


DECLARE SUB AppendButton ()
DECLARE SUB AppendInput (ainputname$)
DECLARE SUB AppendUrl (url$, Texte$)
DECLARE SUB AppendText (Texte$)

DECLARE SUB FlushCache (fichier$)
DECLARE SUB File2Cache (infile$, outfile$)
DECLARE FUNCTION GetCacheNbrLine% (fichier$)
DECLARE FUNCTION GetCacheLine$ (fichier$, linenum%)
DECLARE SUB redrawScreen (mode%)
DECLARE SUB redrawtexte ()
DECLARE FUNCTION Display.QML% (FileHandler$, xpos%, ypos%)
DECLARE FUNCTION urltourl$ (url$)
DECLARE FUNCTION curl$ (chaine$)
DECLARE FUNCTION GetDoc$ (fichier$, rep$)
DECLARE SUB DownloadPage (url$)
DECLARE SUB FlushPage ()
DECLARE SUB LoadPage (url$)

IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	GUI.Init
	MouseShow
	alert (txtAlertNonetwork)
	app.Exit
END IF


DIM SHARED ScrollView AS INTEGER

CLEAR , , 8000
'ON ERROR GOTO gestineerreur
CONST MaxCache = 5
CONST maxform = 3
CONST MaxInput = maxform * 5

DEF fnup$ = CHR$(0) + CHR$(&H48)
DEF fndown$ = CHR$(&H0) + CHR$(&H50)

'l'interface
DIM SHARED History(1 TO 20) AS STRING
DIM SHARED NbrHistory AS INTEGER
DIM SHARED HistoryPos AS INTEGER
DIM SHARED NextBtn AS button
DIM SHARED PrevBtn AS button

DIM SHARED winx1 AS INTEGER, winx2 AS INTEGER, winy1 AS INTEGER, Winy2 AS INTEGER
DIM SHARED FirstLine AS INTEGER
DIM SHARED FirstCol AS INTEGER
DIM SHARED nbrline AS INTEGER
DIM SHARED MaxLine AS INTEGER
DIM SHARED MaxCol AS INTEGER
DIM SHARED CurX AS INTEGER
DIM SHARED CurY AS INTEGER
DIM SHARED assenceurlen AS INTEGER
DIM SHARED aurl AS TextBox

DIM SHARED QmlBGColor AS INTEGER
DIM SHARED fgcolor AS INTEGER
DIM SHARED bbgcolor AS INTEGER
DIM SHARED bfgcolor AS INTEGER

'les hyperliens
DIM SHARED NbrUrl AS INTEGER
DIM SHARED urls(1 TO 40) AS clicZone
DIM SHARED links(1 TO 40) AS STRING

'les downloads
DIM SHARED nbrDurl AS INTEGER
DIM SHARED durls(1 TO 40) AS clicZone
DIM SHARED dlinks(1 TO 40) AS STRING

'les inputs
DIM SHARED NbrInput AS INTEGER
DIM SHARED Inputs(1 TO MaxInput) AS TextBox
DIM SHARED inputname(1 TO MaxInput) AS STRING
DIM SHARED InputParrent(1 TO MaxInput) AS STRING

'les forms
DIM SHARED nbrform AS INTEGER
DIM SHARED formtarget$(1 TO maxform)
DIM SHARED formname$(1 TO maxform)
DIM SHARED SubmitBtn(1 TO maxform) AS button
DIM SHARED formend$(1 TO maxform)

'le timer pour autorefresh
DIM SHARED RefreshTime AS INTEGER
DIM SHARED compteur AS INTEGER
DIM SHARED time&
DIM SHARED RefreshPage AS STRING

'Les pages embarques
DIM SHARED MainPageName AS STRING
DIM SHARED MainPageLines AS INTEGER
DIM SHARED MainPageCache AS STRING
DIM SHARED EmbeddedPageName(1 TO MaxCache) AS STRING
DIM SHARED EmbeddedPageCache(1 TO MaxCache) AS STRING
DIM SHARED EmbeddedCount AS INTEGER
DIM SHARED ScrollArray AS INTEGER
DIM SHARED HomeBtn AS button
DIM scrollaray AS INTEGER
App.SetTitle txtTitle
App.AddMenuItem txtMenuHomepage
App.AddMenuItem txtMenuMark
App.AddMenuItem txtMenuBookmarks

App.AddMenuItem txtMenuExit
DIM SHARED fheight%
fheight% = 8
winx = 640
winy = 356
winx1 = (640 - winx) / 2
winy1 = ((480 - winy) / 2) + 15
winx2 = winx1 + winx
Winy2 = winy1 + winy
MaxLine = ((Winy2 - winy1 - 20) \ fheight%) + 1
MaxCol = ((winx2 - winx1) \ 8)
assenceurlen = ((Winy2 - 29) - (winy1 + 29))

MouseHide
GUI.Init
Init.TextBox aurl, winx1 + 70, winy1 - 20, 60
Debut:
A$ = RegRead("QMLB:home")
IF A$ <> "" THEN
	aurl.Text = A$
ELSE
	aurl.Text = "http://theguiblog.com/qml.php"
END IF
aurl.TextLen = LEN(LTRIM$(RTRIM$(aurl.Text)))
Initx.Button HomeBtn, "Home", winx1 + 10, winy1 - 20, winx1 + 60, winy1 - 5

MouseShow
EditMode = 0
LoadPage LTRIM$(RTRIM$(aurl.Text))
SelUrl$ = ""
ScrollView = 0
History(1) = LTRIM$(RTRIM$(aurl.Text))
NbrHistroy = 1
HistoryPos = 1
DO
	IF (HistoryPos < NbrHistory) THEN
		IF Click.Button(NextBtn) THEN
			HistoryPos = HistoryPos + 1
			aurl.Text = History(HistoryPos)
			aurl.TextLen = LEN(LTRIM$(RTRIM$(aurl.Text)))
			Draw.TextBox aurl
			LoadPage History(HistoryPos)

		END IF
	END IF
	IF HistoryPos > 1 THEN
		IF Click.Button(PrevBtn) THEN
			HistoryPos = HistoryPos - 1
			aurl.Text = History(HistoryPos)
			aurl.TextLen = LEN(LTRIM$(RTRIM$(aurl.Text)))
			Draw.TextBox aurl
			LoadPage History(HistoryPos)

		END IF
	END IF
	IF Click.Button(HomeBtn) THEN GOTO Debut
	tok = 1
	NoReloadName = 0
	A$ = ""
	Manage.TextBox aurl
	
	
	IF aurl.TextChanged THEN
			A$ = LEFT$(aurl.Text, aurl.TextLen)
			IF A$ <> "" THEN
				filename$ = A$
				LoadPage filename$
			END IF
	END IF

	FOR kz = 1 TO NbrInput
		Manage.TextBox Inputs(kz)
	NEXT kz
	       
	FOR kz = 1 TO nbrform
		IF SubmitBtn(kz).pressed THEN tok = 0
		IF Click.Button(SubmitBtn(kz)) THEN
		  tok = 0
		 furl$ = formtarget$(kz)

		 arg$ = ""
		 FOR i = 1 TO NbrInput
		     IF LTRIM$(RTRIM$(LCASE$(InputParrent(i)))) = LTRIM$(RTRIM$(LCASE$(formname$(kz)))) THEN
			arg$ = arg$ + LTRIM$(RTRIM$(inputname(i))) + "=" + LTRIM$(RTRIM$(StrEncode(LEFT$(Inputs(i).Text, Inputs(i).TextLen))))
			IF i < NbrInput THEN arg$ = arg$ + "&"
		     END IF
		 NEXT i
		 IF LTRIM$(RTRIM$(formend$(kz))) <> "" THEN
			IF LTRIM$(RTRIM$(arg$)) <> "" THEN
				arg$ = LTRIM$(RTRIM$(formend$(kz))) + "&" + LTRIM$(RTRIM$(arg$))
			ELSE
				arg$ = LTRIM$(RTRIM$(formend$(kz)))
			END IF
		 END IF

		 IF arg$ <> "" THEN furl$ = LTRIM$(RTRIM$(furl$)) + "?" + LTRIM$(RTRIM$(arg$))
		 aurl.Text = furl$
		 aurl.TextLen = LEN(furl$)
		 Draw.TextBox aurl
		 IF NbrHistory < 20 THEN
		 HistoryPos = HistoryPos + 1
		 NbrHistory = HistoryPos
		 History(NbrHistory) = LTRIM$(RTRIM$(aurl.Text))
		 ELSE
			FOR zi = 1 TO 19
				History(zi) = History(zi + 1)
			NEXT zi
			History(20) = LTRIM$(RTRIM$(aurl.Text))
		 END IF
		 LoadPage furl$
		END IF
	NEXT kz
       
	HoverUrl = 0
	FOR i = 1 TO NbrUrl
		IF i < 10 THEN
			IF MouseZOne(urls(i).x1, urls(i).y1, urls(i).x2, urls(i).y2) THEN HoverUrl$ = "link : " + links(i)
		END IF

		manage.ClicZone urls(i)
		IF urls(i).Cliqued THEN
				aurl.Text = links(i)
				aurl.TextLen = LEN(links(i))
				Draw.TextBox aurl
				filename$ = links(i)
		 IF NbrHistory < 20 THEN
		 HistoryPos = HistoryPos + 1
		 NbrHistory = HistoryPos
		 History(NbrHistory) = LTRIM$(RTRIM$(aurl.Text))
		 ELSE
			FOR zi = 1 TO 19
				History(zi) = History(zi + 1)
			NEXT zi
			History(20) = LTRIM$(RTRIM$(aurl.Text))
		 END IF
		
		 LoadPage filename$
		END IF
	NEXT i
	FOR i = 1 TO nbrDurl
		IF i < 10 THEN
			IF MouseZOne(durls(i).x1, durls(i).y1, durls(i).x2, durls(i).y2) THEN HoverUrl$ = "Download : " + dlinks(i)
		END IF

		manage.ClicZone durls(i)
		IF durls(i).Cliqued THEN
				'tlcharger dlinks(i)
				DownloadFile dlinks(i)
		END IF

	NEXT i

	IF SelUrl$ <> HoverUrl$ THEN
		IF HoverUrl$ = "" THEN
			Draw.StatusBar ""
		ELSE
			Draw.StatusBar HoverUrl$
		END IF
		SelUrl$ = HoverUrl$
	END IF
	A$ = INKEY$
	IF (A$ = fnup$) THEN
		IF FirstLine > 0 THEN
			IF EditMode = -1 THEN OldFirstLine = FirstLine
			FirstLine = FirstLine - (MaxLine - 1)
			IF FirstLine < 0 THEN FirstLine = 0
			redrawtexte
		END IF
	END IF
	IF (A$ = fndown$) THEN
		IF FirstLine + MaxLine - 1 < nbrline THEN
			IF EditMode = -1 THEN OldFirstLine = FirstLine
			FirstLine = FirstLine + (MaxLine - 1)
			redrawtexte
		END IF
	END IF
						 

	App.ManageKey ""
	SELECT CASE SelectedMenu
		CASE txtMenuBookmarks
			GOSUB OpenDoc
		CASE txtMenuMark
			GOSUB BookMarkPage:
		CASE txtMenuExit
			app.Exit
		CASE txtMenuHomepage
		RegWrite "QMLB:home", LEFT$(aurl.Text, aurl.TextLen)
	END SELECT

	IF tok = 1 THEN
		IF time& <> INT(TIMER) THEN
		compteur = compteur + 1
		time& = INT(TIMER)
		IF compteur = RefreshTime THEN
			compteur = 0
			aurl.Text = RefreshPage
			aurl.TextLen = LEN(RefreshPage)
			Draw.TextBox aurl
			rfirstline = FirstLine
			LoadPage RefreshPage
			FirstLine = rfirstline
			redrawtexte
		END IF
	       END IF
	ELSE
		compteur = 0
	END IF
LOOP






BookMarkPage:
	     A$ = FileSelect("save", CurrentDir + "\BookMark", "")
	     IF A$ <> "" THEN
		fic = FREEFILE
		OPEN A$ FOR OUTPUT AS fic
			PRINT #fic, LEFT$(aurl.Text, aurl.TextLen)
		CLOSE fic
	     END IF
RETURN

OpenDoc:
	A$ = FileSelect("open", CurrentDir + "\BookMark", "")
IF A$ <> "" THEN
	       fic = FREEFILE
		OPEN A$ FOR INPUT AS fic
			INPUT #fic, url$
		CLOSE fic
		aurl.Text = url$
		aurl.TextLen = LEN(url$)
		Draw.TextBox aurl
		filename$ = url$
		LoadPage url$
END IF
RETURN





gestineerreur:
	reper = 0
	RESUME NEXT

SUB Append.Download (url$, Texte$)
	IF CurY < FirstLine THEN EXIT SUB
	'CurX = CurX + 1
	IF CurX > MaxCol THEN
		CurX = CurX + LEN(Texte$)
		EXIT SUB
	END IF

	ixpos = CurX - FirstCol
	iypos = CurY - FirstLine
	maxlen = MaxCol - ixpos - 1
	IF iypos > MaxLine - 2 THEN EXIT SUB
	afficher$ = Texte$
	IF LEN(afficher$) > maxlen THEN afficher$ = LEFT$(afficher$, maxlen)
	nbrDurl = nbrDurl + 1
	create.cliczone durls(nbrDurl), (winx1 + (ixpos * 8)), (winy1 + 10 + (iypos * fheight%)), (winx1 + 3 + (ixpos * 8) + LEN(afficher$) * 8), (winy1 + 10 + fheight% + (iypos * fheight%)), (QmlBGColor), (fgcolor)
	MouseHide
	LINE (durls(nbrDurl).x1, durls(nbrDurl).y2 - 1)-(durls(nbrDurl).x2, durls(nbrDurl).y2 - 1), (fgcolor)
	MouseShow
	draw.ClicZone durls(nbrDurl)
	AppendText afficher$
	dlinks(nbrDurl) = url$
END SUB

DEFINT A-Z
SUB AppendButton
	IF CurX > MaxCol - 20 THEN
		CurX = 0
		CurY = CurY + 1
	END IF
	IF CurY < FirstLine THEN EXIT SUB
	ixpos = CurX - FirstCol
	iypos = CurY - FirstLine
	maxlen = MaxCol - ixpos
	IF iypos > MaxLine - 3 THEN EXIT SUB

	IF NbrInput > 0 THEN
		x1 = Inputs(1).x1
	ELSE
		x1 = winx1
	END IF
	
	IF (x1 + 100) <= winx2 - 10 THEN
		x2 = x1 + 100
	ELSE
		x2 = winx2 - 10
	END IF
	y1 = winy1 + 10 + (iypos * fheight%)
	IF (y1 + 20 < Winy2 - 10) THEN
		y2 = y1 + (fheight / 8) * 10
	ELSE
		y2 = Winy2 - 10
	END IF
	Initx.Button SubmitBtn(nbrform), txtSubmit, x1, y1, x2, y2
	Draw.Button SubmitBtn(nbrform)
	CurY = CurY + 2
END SUB

SUB AppendInput (ainputname$)
	IF NbrInput >= MaxInput THEN EXIT SUB
	CurX = CurX + 1
	'CurY = CurY + 1
	IF CurX > MaxCol - 20 THEN
		CurX = 0
		CurY = CurY + 1
	END IF
	IF CurY < FirstLine THEN EXIT SUB
	ixpos = CurX - FirstCol
	iypos = CurY - FirstLine
	maxlen = MaxCol - ixpos
	IF iypos > MaxLine - 3 THEN EXIT SUB
	NbrInput = NbrInput + 1
	
	x1 = winx1 + (ixpos * 8)
	y1 = winy1 + 10 + (iypos * fheight%)
	x2 = winx2 - 50
	y2 = y1 + (fheight% / 8) * 10
	Init.TextBox Inputs(NbrInput), (x1), (y1), 10
	inputname(NbrInput) = LTRIM$(RTRIM$(ainputname$))
	InputParrent(NbrInput) = formname$(nbrform)
	Draw.TextBox Inputs(NbrInput)
	CurY = CurY + 2
	CurX = 0
END SUB

SUB AppendText (Texte$)

	'IF cury < FirstLine THEN EXIT SUB
	IF CurX > MaxCol THEN
		CurX = CurX + LEN(Texte$)
		EXIT SUB
	END IF
	FOR i = 1 TO LEN(Texte$)
		IF MID$(Texte$, i, 1) = CHR$(10) OR MID$(Texte$, i, 1) = CHR$(13) THEN
			MID$(Texte$, i, 1) = " "
		END IF
	NEXT i
	ixpos = CurX - FirstCol
	iypos = CurY - FirstLine
	maxlen = (MaxCol) - ixpos
	'IF iypos > MaxLine - 2 THEN EXIT SUB
	IF LEN(Texte$) > maxlen THEN
		FOR i = maxlen - 1 TO 1 STEP -1
			IF MID$(Texte$, i, 1) = " " THEN
				AppendText LEFT$(Texte$, i)
				CurX = 0
				CurY = CurY + 1
				AppendText MID$(Texte$, i + 1)
				EXIT SUB
			END IF
		NEXT i

		AppendText LEFT$(Texte$, maxlen)
		'CurY = CurY + 1
		'Curx = 0
		AppendText MID$(Texte$, maxlen + 1)
		EXIT SUB
	ELSE
		afficher$ = Texte$
		'IF LEN(afficher$) < MaxLen THEN afficher$ = afficher$ + STRING$(MaxLen - LEN(afficher$), " ")
		MouseHide
		IF iypos >= 0 AND iypos < MaxLine - 1 THEN Draw.Text afficher$, (winx1 + (ixpos * 8)), (winy1 + 10 + (iypos * fheight%)), (fgcolor), (QmlBGColor)
		MouseShow
	END IF
	CurX = CurX + LEN(Texte$)
	IF CurX >= MaxCol THEN
		CurX = 0
		CurY = CurY + 1
	END IF
END SUB

SUB AppendUrl (url$, Texte$)
	IF CurY < FirstLine THEN EXIT SUB
	'CurX = CurX + 1
	IF CurX > MaxCol THEN
		CurX = CurX + LEN(Texte$)
		EXIT SUB
	END IF

	ixpos = CurX - FirstCol
	iypos = CurY - FirstLine
	maxlen = MaxCol - ixpos - 1
	IF iypos > MaxLine - 3 THEN EXIT SUB
	afficher$ = Texte$
	IF LEN(afficher$) > maxlen THEN afficher$ = LEFT$(afficher$, maxlen)
	NbrUrl = NbrUrl + 1
	create.cliczone urls(NbrUrl), (winx1 + (ixpos * 8)), (winy1 + 10 + (iypos * fheight%)), (winx1 + 3 + (ixpos * 8) + LEN(afficher$) * 8), (winy1 + 10 + fheight% + (iypos * fheight%)), (QmlBGColor), (fgcolor)
	MouseHide
	LINE (urls(NbrUrl).x1, urls(NbrUrl).y2 - 1)-(urls(NbrUrl).x2, urls(NbrUrl).y2 - 1), (fgcolor)
	MouseShow
	draw.ClicZone urls(NbrUrl)
	AppendText afficher$
	links(NbrUrl) = url$
END SUB

FUNCTION curl$ (chaine$)
	retval$ = ""
	FOR i = 1 TO LEN(chaine$)
		SELECT CASE MID$(chaine$, i, 1)
			CASE CHR$(0)
				retval$ = retval$
			CASE " "
				retval$ = retval$ + "%20"
			CASE CHR$(34)
			       retval$ = retval$ + "%22"
			CASE "#"
				retval$ = retval$ + "%23"
			CASE "$"
				retval$ = retval$ + "%24"
			CASE "&"
				retval$ = retval$ + "%26"
			CASE "'"
				retval$ = retval$ + "%27"
			CASE "+"
				retval$ = retval$ + "%2b"
			CASE ","
				retval$ = retval$ + "%2c"
			CASE "/"
				retval$ = retval$ + "%2f"
			CASE ":"
				retval$ = retval$ + "%3a"
			CASE ";"
				retval$ = retval$ + "%3b"
			CASE "="
				retval$ = retval$ + "%3d"
			CASE "?"
				retval$ = retval$ + "%3f"
			CASE "@"
				retval$ = retval$ + "%40"
			CASE "["
				retval$ = retval$ + "%5b"
			CASE "\"
				retval$ = retval$ + "%5c"
			CASE "]"
				retval$ = retval$ + "%5d"
			CASE "^"
				retval$ = retval$ + "%5e"



			CASE ""
				retval$ = retval$ + "%e0"
			CASE ""
				retval$ = retval$ + "%e2"
			CASE ""
				retval$ = retval$ + "%e2"
			CASE ""
				retval$ = retval$ + "%e7"
			CASE ""
				retval$ = retval$ + "%e8"
			CASE ""
				retval$ = retval$ + "%e9"
			CASE ""
				retval$ = retval$ + "%ea"
			CASE ""
				retval$ = retval$ + "%ea"
			CASE ""
				retval$ = retval$ + "%ee"
			CASE ""
				retval$ = retval$ + "%ee"
			CASE ""
				retval$ = retval$ + "%f4"
			CASE ""
				retval$ = retval$ + "%f4"
			CASE ""
				retval$ = retval$ + "%f9"
			CASE ""
				retval$ = retval$ + "%fb"
			CASE ""
				retval$ = retval$ + "%fb"
			CASE ELSE
				retval$ = retval$ + MID$(chaine$, i, 1)
		END SELECT
	NEXT i
	curl$ = retval$
END FUNCTION

FUNCTION Display.QML (FileHandler$, xpos, ypos)
InForm = 0
fh% = fheight%
	mbrline% = GetCacheNbrLine(FileHandler$)
	fgcolor = 7
	QmlBGColor = 0
	bggcolor = 0
	bfgcolor = 7
       
	MouseHide
	frac = FREEFILE

	OPEN FileHandler$ FOR INPUT AS frac
	FOR i = 0 TO mbrline - 1
	   
		'chaine$ = GetCacheLine(FileHandler$, I)
		LINE INPUT #frac, chaine$
		cmd$ = UCASE$(LEFT$(chaine$, 1))
		Contenu$ = ""
		IF LEN(chaine$) > 1 THEN Contenu$ = MID$(chaine$, 2)
		SELECT CASE cmd$
			CASE "$"
			'display text
				AppendText Contenu$
			CASE "C"
			'display ascci character
			  IF Contenu$ <> "" THEN
				AppendText CHR$(VAL(Contenu$))
			  END IF
			CASE "|"
				IF CurX = 0 THEN
					AppendText STRING$(80 - CurX, " ")
				ELSE
					AppendText STRING$(80 - CurX, " ")
					CurY = CurY - 1
				END IF
				FOR z = 0 TO LEN(LTRIM$(RTRIM$(Contenu$)))
					CurX = 0
					CurY = CurY + 1
					AppendText STRING$(80, " ")
				NEXT z
				CurX = 0
				CurY = CurY - 1
			 
			CASE "="
			'horizontal rule
				IF (CurX > 0) THEN
					CurX = 0
					CurY = CurY + 1
				END IF
				IF LTRIM$(RTRIM$(Contenu$)) = "" THEN
				       hrule$ = STRING$(MaxCol, "-")
				ELSE

				       hrule$ = STRING$(MaxCol, CHR$(VAL(LTRIM$(RTRIM$(Contenu$)))))
				END IF
				AppendText hrule$
				'CurY = CurY + 1
				'CurX = 0
			CASE "#"
			'change foreground color
				IF LTRIM$(RTRIM$(Contenu$)) <> "" THEN
					fgcolor = VAL(LTRIM$(RTRIM$(Contenu$)))
				ELSE
					fgcolor = bfgcolor
				END IF
			CASE ":"
			'change background color
				IF LTRIM$(RTRIM$(Contenu$)) <> "" THEN
				       QmlBGColor = VAL(LTRIM$(RTRIM$((Contenu$))))
				ELSE
					QmlBGColor = bbgcolor
				END IF
				'tXpos = Xpos
				'tYpos = ypos
				'AppendText STRING$(80 - CurX, " ")
				'Xpos = tXpos
				'ypos = tYpos
			CASE "F"
			'set default foreground
				bfgcolor = VAL(LTRIM$(RTRIM$(Contenu$)))
			       
			CASE "B"
				
			'set default background
				bbgcolor = VAL(LTRIM$(RTRIM$(Contenu$)))
				IF CurY - FirstLine <= MaxLine - 2 THEN
					MouseHide
					zypos = CurY - FirstLine
					IF zypos < 0 THEN zypos = 0
					
					LINE ((winx1), winy1 + 8 + (zypos * fh%))-(winx2, (Winy2 - 9)), bbgcolor, BF
					MouseShow
				END IF
			CASE "_"
			'insert hyperlink
			IF Contenu$ <> "" AND LEN(Contenu$) > 3 AND InForm = 0 THEN
			   FOR z = 1 TO LEN(Contenu$)
				IF MID$(Contenu$, z, 1) = ">" THEN
					Texte$ = LEFT$(Contenu$, z - 1)
					Texte$ = " " + Texte$ + " "
					url$ = MID$(Contenu$, z + 1)
					AppendUrl url$, Texte$
					EXIT FOR
				END IF
			   NEXT z
			END IF
			CASE "^"
			'insert download link
			IF Contenu$ <> "" AND LEN(Contenu$) > 3 AND InForm = 0 THEN
			   FOR z = 1 TO LEN(Contenu$)
				IF MID$(Contenu$, z, 1) = ">" THEN
					Texte$ = LEFT$(Contenu$, z - 1)
					Texte$ = " " + Texte$ + " "
					url$ = MID$(Contenu$, z + 1)
					Append.Download url$, Texte$
					EXIT FOR
				END IF
			   NEXT z
			END IF
			CASE CHR$(34) ' = "
			'embed text file
			IF Contenu$ <> "" AND InForm = 0 THEN
				aypos = aypos + 1
				axpos = 0
				FOR zks = 1 TO EmbeddedCount
					IF EmbeddedPageName(zks) = Contenu$ THEN
						zkl = GetCacheNbrLine(EmbeddedPageCache(zks))
						froc = FREEFILE
						OPEN EmbeddedPageCache(zks) FOR INPUT AS froc
						FOR jkl = 0 TO zkl - 1
							'aligne$ = GetCacheLine(EmbeddedPageCache(zks), jkl)
							LINE INPUT #froc, aligne$
							AppendText aligne$
							CurX = 0
							CurY = CurY + 1
						NEXT jkl
						CLOSE froc
						EXIT FOR
					END IF
				NEXT zks
			END IF
			CASE "+"
			'embed qml
			IF Contenu$ <> "" AND InForm = 0 THEN
				FOR zks = 1 TO EmbeddedCount
					IF EmbeddedPageName(zks) = Contenu$ THEN
						aypos = aypos + Display.QML(EmbeddedPageCache(zks), xpos, ypos)
					END IF
				NEXT zks
			END IF

			CASE "-"
			'center text
				Text$ = Contenu$
				IF LEN(Contenu$) < MaxCol THEN
					l% = ((MaxCol - LEN(Contenu$)) / 2) - 1
					IF l% <= 0 THEN l% = 1
				END IF
				chaine$ = STRING$(l%, " ") + Text$ + STRING$(l%, " ")
				IF CurX > 0 THEN
					CurX = 0
					CurY = CurY + 1
				END IF
				AppendText chaine$
			CASE "["
			'debut d'un formulaire
			Contenu$ = LTRIM$(RTRIM$(Contenu$))
			 IF Contenu$ <> "" AND LEN(Contenu$) > 3 AND InForm = 0 AND nbrform < maxform THEN
				FOR z = 1 TO LEN(Contenu$)
					IF MID$(Contenu$, z, 1) = ">" THEN
						nbrform = nbrform + 1
						formname$(nbrform) = LEFT$(Contenu$, z - 1)
						formtarget$(nbrform) = MID$(Contenu$, z + 1)
						InForm = -1
						EXIT FOR
					END IF
				NEXT z
			       
			       
			   END IF

			 CASE "]"
				IF InForm = -1 THEN
					formend$(nbrform) = ""
					IF Contenu$ <> "" THEN
						IF ASC(LEFT$(Contenu$, 1)) > 25 THEN
							formend$(nbrform) = LTRIM$(RTRIM$(Contenu$))
						END IF
					END IF
					AppendButton
				END IF
				InForm = 0
			CASE "?"
				IF Contenu$ <> "" AND InForm = -1 THEN
					AppendInput Contenu$
				END IF
			CASE "~"
				IF LTRIM$(RTRIM$(Contenu$)) <> "" THEN
					cpt = 0
					FOR z = 1 TO LEN(Contenu$)
						IF MID$(Contenu$, z, 1) = ">" THEN
							cpt = VAL(LEFT$(Contenu$, z - 1)) * 2
							url$ = MID$(Contenu$, z + 1)
							EXIT FOR
						END IF
					NEXT z
					IF cpt = 0 THEN cpt = VAL(Contenu$)
					RefreshTime = cpt
					RefreshPage = url$
				END IF
			'isbreak = 0
		END SELECT
		'IF (aypos + 2) > (Ypos + MaxLine) THEN EXIT FOR
	NEXT i
	CLOSE frac
	MouseShow
	Display.QML = CurY + 2'aypos + 1
END FUNCTION

DEFSNG A-Z
SUB DownloadFile (url$)
	defname$ = url$
	FOR i = LEN(url$) TO 1 STEP -1
		IF MID$(url$, i, 1) = "/" THEN
		defname$ = MID$(url$, i + 1)
		EXIT FOR
		END IF
	NEXT i
	A$ = FileSelect("Save", "", "")
	IF A$ <> "" THEN
		Net.DownloadPageNoPost url$, A$
	END IF
END SUB

DEFINT A-Z
SUB DownloadPage (url$)
	MainPageName = url$
	A$ = url$
	IF UCASE$(LEFT$(url$, 5)) <> "DOCS\" THEN A$ = GetDoc(url$, "fqml.dat")
	MainPageCache = "cache\main.dat"
	File2Cache A$, MainPageCache
	'KILL a$
	
		MainPageLines = GetCacheNbrLine(MainPageCache)
		fic = FREEFILE
		OPEN MainPageCache FOR INPUT AS fic
		FOR i = 0 TO MainPageLines - 1
			'chaine$ = GetCacheLine(MainPageCache, I)
			LINE INPUT #fic, chaine$
			cmd$ = LTRIM$(RTRIM$(UCASE$(LEFT$(chaine$, 1))))
			Contenu$ = ""
			IF LEN(chaine$) > 1 THEN Contenu$ = MID$(chaine$, 2)
			IF cmd$ = "+" OR cmd$ = CHR$(34) THEN
				IF Contenu$ <> "" THEN
					IF cmd$ = "+" THEN frep$ = "fqml.dat"
					IF cmd$ = CHR$(34) THEN frep$ = "ftext.dat"
					f$ = GetDoc(Contenu$, frep$)
					IF f$ <> "" THEN
						EmbeddedCount = EmbeddedCount + 1
						EmbeddedPageName(EmbeddedCount) = Contenu$
						EmbeddedPageCache(EmbeddedCount) = "cache\" + LTRIM$(RTRIM$(STR$(EmbeddedCount))) + ".dat"
						File2Cache f$, EmbeddedPageCache(EmbeddedCount)
					END IF
				END IF
			END IF
			IF EmbeddedCount >= MaxCache THEN EXIT FOR
		NEXT i
		CLOSE fic

END SUB

DEFSNG A-Z
SUB Draw.StatusBar (Text AS STRING)
	Draw.Frame 0, 460, 639, 479
	Draw.Text Text, 3, 466, TextColor, BgColor
END SUB

DEFINT A-Z
SUB File2Cache (infile$, outfile$)
	DIM taille AS INTEGER
	DIM car AS STRING * 1
	DIM chaine AS STRING
	IF infile$ = "" THEN
		EXIT SUB
	END IF
	fic = FREEFILE
	OPEN infile$ FOR BINARY AS fic
	fic2 = FREEFILE
	OPEN outfile$ FOR OUTPUT AS fic2
		taille = LOF(fic)
		DO WHILE NOT EOF(fic)
			GET #fic, , car
			IF car = CHR$(10) OR car = CHR$(13) THEN
				'ipos = ipos + 1
				'WHILE (cara = CHR$(13) OR cara$ = CHR$(10)) AND ipos < taille + 2
				'        MoveFromXMS handler%, VARSEG(cara), SADD(cara), 1, ipos
				'        ipos = ipos + 1
				'WEND
				PRINT #fic2, chaine
				chaine$ = ""
			ELSE
				IF car <> CHR$(13) AND car <> CHR$(0) AND car <> "" AND car <> CHR$(10) THEN chaine = chaine + car
			END IF
		       
		LOOP
		chaine = chaine + CHR$(10)
		PRINT #fic2, chaine
	CLOSE fic2
	CLOSE fic
	
END SUB

SUB FlushCache (fichier$)
	CLOSE
	IF fichier$ <> "" THEN KILL fichier$
END SUB

SUB FlushPage
	MainPageName = ""
	FlushCache MainPageCache
	MainPageCache = ""
	FOR i = 1 TO EmbeddedCount
		EmbeddedPageName(i) = ""
		FlushCache EmbeddedPageCache(i)
		EmbeddedPageCache(i) = ""
	NEXT i
	EmbeddedCount = 0

END SUB

FUNCTION GetCacheLine$ (fichier$, linenum%)
	IF fichier$ = "" THEN EXIT FUNCTION
	fic = FREEFILE
	OPEN fichier$ FOR INPUT AS fic
	WHILE NOT EOF(fic)
		LINE INPUT #fic, chaine$
		IF linenum% = nbrl THEN
			GetCacheLine$ = chaine$
			EXIT FUNCTION
		END IF
		nbrl = nbrl + 1
	WEND
	CLOSE fic
	GetCacheLine$ = ""
END FUNCTION

FUNCTION GetCacheNbrLine (fichier$)
	IF fichier$ = "" THEN EXIT FUNCTION
	fic = FREEFILE
	OPEN fichier$ FOR INPUT AS fic
	WHILE NOT EOF(fic)
		LINE INPUT #fic, chaine$
		nbrl = nbrl + 1
	WEND
	CLOSE fic
	GetCacheNbrLine = nbrl
END FUNCTION

FUNCTION GetDoc$ (fichier$, rep$)
	'soit on doit le telecharger
	IF LCASE$(LEFT$(fichier$, 7)) = "http://" AND LEN(fichier$) > 8 THEN
		fic = FREEFILE
		Net.DownloadPageNoPost fichier$, "out.dat"
		GetDoc$ = "out.dat"
		EXIT FUNCTION
	ELSE
	       'si on est ici c'est que le repertoire est sur le disque
		GetDoc$ = rep$ + "/" + fichier$
		EXIT FUNCTION
	END IF
END FUNCTION

SUB LoadPage (url$)
	FlushPage
	CurX = 0
	CurY = 0
	FirstLine = 0
	fgcolor = 7
	QmlBGColor = 0
	bfgcolor = 7
	bbgcolor = 0
       
	DownloadPage (url$)
	redrawScreen (1)
	compteur = 0
	Draw.StatusBar url$
	time& = INT(TIMER)

END SUB

SUB redrawScreen (mode%)
	MouseHide
	App.DrawGui
	Draw.StatusBar ""
	Draw.Frame 0, winy1 - 30, 639, winy1 + 8
	Draw.Frame winx1 - 8, winy1 + 6, winx2 + 8, Winy2 - 6
	Initx.Button NextBtn, ">", winx2 - 20, winy1 - 25, winx2 - 5, winy1 - 10
	Initx.Button PrevBtn, "<", winx2 - 40, winy1 - 25, winx2 - 25, winy1 - 10


	IF mode% = 1 THEN redrawtexte
	Draw.TextBox aurl
	Draw.Button HomeBtn
	Draw.Button PrevBtn
	Draw.Button NextBtn
	MouseShow
END SUB

SUB redrawtexte
	MouseHide
	LINE (winx1, winy1 + 8)-(winx2, Winy2 - 8), bbgcolor, BF
	NbrUrl = 0
	nbrDurl = 0
	FOR i = 1 TO NbrInput
		Inputs(i).Text = ""
		Inputs(i).TextLen = 0
		inputname(i) = ""
		InputParrent(i) = ""
	NEXT i
	NbrInput = 0

	FOR kz = 1 TO maxform
		formtarget$(kz) = ""
		formname$(kz) = ""
		formend$(kz) = ""
	NEXT kz
	CurX = 0
	CurY = 0

	nbrform = 0
	RefreshTime = 0
	RefreshPage = ""
	nbrline = Display.QML(MainPageCache, 0, FirstLine)
	IF RefreshPage = "" THEN RefreshPage = LEFT$(aurl.Text, aurl.TextLen)
	CurX = 0
	CurY = 0
       
	MouseShow

END SUB

FUNCTION urltourl$ (url$)
	retval$ = url$
	FOR i = 1 TO LEN(url$)
		IF MID$(url$, i, 1) = "?" THEN
		retval$ = LEFT$(url$, i - 1)
		EXIT FOR
		END IF
	NEXT i
	urltourl$ = retval$
END FUNCTION

