CONST MaxChanel = 8
CONST MaxNotes = 256
TYPE MusFileHeader
        Tag AS STRING * 4'must be xMUS
        Author AS STRING * 20'the author
        Title AS STRING * 20 'the title
        Descr AS STRING * 50 ' the description
        ChanelCount AS INTEGER
END TYPE

TYPE ChanelHeader
        NotesCount AS INTEGER
END TYPE

TYPE Note
        Num AS STRING * 1'from 0 to 11,
        Octave AS STRING * 1' the octave
END TYPE

DIM SHARED Chanels(1 TO MaxChanel) AS ChanelHeader
DIM SHARED Notes(1 TO MaxChanel, 2 TO MaxNotes) AS Note

'Frequency from each notes in the octave 1
DIM SHARED notef(0 TO 11) AS INTEGER
FOR i = 0 TO 11
        notef(i) = (440 * 2 ^ ((0) + ((i - 9) / 12))) '/ 4
NEXT i

SUB LoadMusFile (fichier AS STRING)
        fic = FREEFILE
        DIM Header AS MusFileHeader
        DIM cheader AS ChanelHeader
        DIM NoteVoid AS Note
        OPEN fichier FOR BINARY AS fic
                GET #fic, , Header
                IF Header.Tag <> "xMUS" THEN
                        CLOSE fic
                        EXIT SUB
                END IF
                IF Header.ChanelCount > MaxChanel THEN Header.ChanelCount = MaxChanel
                FOR i = 1 TO Header.ChanelCount
                        GET #fic, , Chanels(i)
                        FOR j = 1 TO Chanels(i).NotesCount
                                IF j <= MaxNotes THEN
                                        GET #fic, , Notes(i, j)
                                ELSE
                                        GET #fic, , NoteVoid
                                END IF
                        NEXT j
                NEXT i
        CLOSE fic
END SUB

