'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\locale.bi'

TYPE persone
	Prenom AS STRING * 20
	Nom AS STRING * 20
	Addresse AS STRING * 50
	Numero AS STRING * 5
	CodePostal AS STRING * 10
	Ville AS STRING * 20
	Pays AS STRING * 20
	Telephone AS STRING * 50
	Email AS STRING * 50
END TYPE

DIM liste(1 TO 100) AS persone
DIM NbrContact AS INTEGER
DIM CurrentView AS INTEGER
NbrContact = 0
CurrentView = 0

DIM DelButton AS button
DIM AddButton AS button
DIM NextButton AS button
DIM PrevButton AS button
DIM Prenom AS TextBox
DIM Nom AS TextBox
DIM Addresse AS TextBox
DIM Numero AS TextBox
DIM CodePostal AS TextBox
DIM Ville AS TextBox
DIM Pays AS TextBox
DIM Telephone AS TextBox
DIM Email AS TextBox


DIM Menu(0 TO 5, 0 TO 10) AS STRING
DIM menudata(5000)
App.SetTitle Localize("contact.str", "txtTitle")
App.AddMenuItem Localize("system.str", "txtSave")
App.AddMenuItem Localize("system.str", "txtExit")
DIM winx AS INTEGER, winy AS INTEGER, WinX1 AS INTEGER, winx2 AS INTEGER, winy1 AS INTEGER, winy2 AS INTEGER
winx = 450
winy = 280
WinX1 = (640 - winx) / 2
winx2 = WinX1 + winx
winy1 = (480 - winy) / 2
winy2 = winy1 + winy

Initx.Button DelButton, "-", WinX1 + 10, winy2 - 30, WinX1 + 50, winy2 - 10
Initx.Button PrevButton, "<", WinX1 + 60, winy2 - 30, WinX1 + 100, winy2 - 10
Initx.Button NextButton, ">", winx2 - 100, winy2 - 30, winx2 - 60, winy2 - 10
Initx.Button AddButton, "+", winx2 - 50, winy2 - 30, winx2 - 10, winy2 - 10

Init.TextBox Prenom, WinX1 + 125, winy1 + 44, 13
Init.TextBox Nom, WinX1 + 290, winy1 + 44, 13
Init.TextBox Addresse, WinX1 + 125, winy1 + 79, 20
Init.TextBox Numero, winx2 - 60, winy1 + 79, 5
Init.TextBox CodePostal, WinX1 + 125, winy1 + 114, 5
Init.TextBox Ville, WinX1 + 260, winy1 + 114, 20
Init.TextBox Pays, WinX1 + 125, winy1 + 149, 20
Init.TextBox Telephone, WinX1 + 125, winy1 + 184, 20
Init.TextBox Email, WinX1 + 125, winy1 + 214, 20


GOSUB LoadFile
CurrentView = NbrContact
GUI.Init
App.DrawGui
Draw.Window WinX1, winy1, winx2, winy2, Localize("contact.str", "txtEditorTitle")
Draw.Button PrevButton
Draw.Button NextButton
Draw.Button AddButton
Draw.Button DelButton
GOSUB LoadView
MouseShow
DIM quiter AS INTEGER
quiter = 0
DO
	App.Manage
	IF CurrentView > 0 THEN
		Manage.TextBox Nom
		Manage.TextBox Prenom
		Manage.TextBox Addresse
		Manage.TextBox Numero
		Manage.TextBox CodePostal
		Manage.TextBox Ville
		Manage.TextBox Pays
		Manage.TextBox Telephone
		Manage.TextBox Email
	END IF
	IF Click.Button(AddButton) AND NbrContact < 100 THEN
	      IF CurrentView > 0 THEN GOSUB SaveView
	      NbrContact = NbrContact + 1
	      CurrentView = NbrContact
	      liste(CurrentView).Nom = ""
	      liste(CurrentView).Prenom = ""
	      liste(CurrentView).Addresse = ""
	      liste(CurrentView).Numero = ""
	      liste(CurrentView).CodePostal = ""
	      liste(CurrentView).Ville = ""
	      liste(CurrentView).Pays = ""
	      liste(CurrentView).Telephone = ""
	      liste(CurrentView).Email = ""
	      MouseHide
	      GOSUB LoadView
	      MouseShow
	END IF
	IF Click.Button(DelButton) AND NbrContact > 0 THEN
		NbrContact = NbrContact - 1
		FOR i = CurrentView TO NbrContact
			liste(i) = liste(i + 1)
		NEXT i
		IF CurrentView > NbrContact THEN CurrentView = CurrentView - 1
		MouseHide
		GOSUB LoadView
		MouseShow
	END IF
	IF Click.Button(NextButton) AND NbrContact > 0 THEN
	      GOSUB SaveView
	      CurrentView = CurrentView + 1
	      IF CurrentView > NbrContact THEN CurrentView = 1
	      MouseHide
	      GOSUB LoadView
	      MouseShow
	END IF
	IF Click.Button(PrevButton) AND NbrContact > 0 THEN
	      GOSUB SaveView
	      CurrentView = CurrentView - 1
	      IF CurrentView < 1 THEN CurrentView = NbrContact
	      MouseHide
	      GOSUB LoadView
	      MouseShow
	END IF
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE Localize("system.str", "txtSave")
			GOSUB SaveView
			GOSUB SaveFile
		CASE "Exit"
			App.Exit
		CASE Localize("system.str", "txtExit")
			App.Exit
	END SELECT
	END IF

LOOP

LoadView:
	LINE (WinX1 + 110, winy2 - 30)-(winx2 - 110, winy2 - 10), BgColor, BF
	LINE (WinX1 + 110, winy2 - 30)-(winx2 - 110, winy2 - 10), BorderColor1, B
	LINE (WinX1 + 10, winy1 + 30)-(winx2 - 10, winy2 - 40), BgColor, BF
	LINE (WinX1 + 10, winy1 + 30)-(winx2 - 10, winy2 - 40), BorderColor1, B

	a$ = LTRIM$(RTRIM$(STR$(CurrentView))) + "/" + LTRIM$(RTRIM$(STR$(NbrContact)))
	Draw.Text a$, ((640 - (LEN(a$) * 8)) / 2), winy2 - 23, TextColor, BgColor

	IF CurrentView > 0 THEN
		Prenom.Text = LTRIM$(RTRIM$(liste(CurrentView).Prenom))
		Prenom.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Prenom)))
		Nom.Text = LTRIM$(RTRIM$(liste(CurrentView).Nom))
		Nom.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Nom)))
		Addresse.Text = LTRIM$(RTRIM$(liste(CurrentView).Addresse))
		Addresse.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Addresse)))
		Numero.Text = LTRIM$(RTRIM$(liste(CurrentView).Numero))
		Numero.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Numero)))
		CodePostal.Text = LTRIM$(RTRIM$(liste(CurrentView).CodePostal))
		CodePostal.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).CodePostal)))
		Ville.Text = LTRIM$(RTRIM$(liste(CurrentView).Ville))
		Ville.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Ville)))
		Pays.Text = LTRIM$(RTRIM$(liste(CurrentView).Pays))
		Pays.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Pays)))
		Telephone.Text = LTRIM$(RTRIM$(liste(CurrentView).Telephone))
		Telephone.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Telephone)))
		Email.Text = LTRIM$(RTRIM$(liste(CurrentView).Email))
		Email.textlen = LEN(LTRIM$(RTRIM$(liste(CurrentView).Email)))


		Draw.Text Localize("contact.str", "txtEditorFirstname"), WinX1 + 20, winy1 + 47, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorLastname"), WinX1 + 250, winy1 + 47, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorStreet"), WinX1 + 20, winy1 + 82, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorHouseNo"), winx2 - 100, winy1 + 82, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorPostal"), WinX1 + 20, winy1 + 117, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorCity"), WinX1 + 210, winy1 + 117, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorCountry"), WinX1 + 20, winy1 + 152, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorPhone"), WinX1 + 20, winy1 + 187, TextColor, BgColor
		Draw.Text Localize("contact.str", "txtEditorEmail"), WinX1 + 20, winy1 + 217, TextColor, BgColor
		Draw.TextBox Prenom
		Draw.TextBox Nom
		Draw.TextBox Numero
		Draw.TextBox Addresse
		Draw.TextBox CodePostal
		Draw.TextBox Ville
		Draw.TextBox Pays
		Draw.TextBox Telephone
		Draw.TextBox Email
	END IF
RETURN
SaveView:
	IF CurrentView > 0 THEN
	liste(CurrentView).Prenom = LTRIM$(RTRIM$(Prenom.Text))
	liste(CurrentView).Nom = LTRIM$(RTRIM$(Nom.Text))
	liste(CurrentView).Addresse = LTRIM$(RTRIM$(Addresse.Text))
	liste(CurrentView).Numero = LTRIM$(RTRIM$(Numero.Text))
	liste(CurrentView).CodePostal = LTRIM$(RTRIM$(CodePostal.Text))
	liste(CurrentView).Ville = LTRIM$(RTRIM$(Ville.Text))
	liste(CurrentView).Pays = LTRIM$(RTRIM$(Pays.Text))
	liste(CurrentView).Telephone = LTRIM$(RTRIM$(Telephone.Text))
	liste(CurrentView).Email = LTRIM$(RTRIM$(Email.Text))
	END IF
RETURN


LoadFile:
	fic = FREEFILE
	OPEN "system\contact.dat" FOR BINARY AS fic
		taille = LOF(fic)
	CLOSE fic
	NbrContact = taille \ 245
	IF NbrContact > 0 THEN
	DEF SEG = VARSEG(liste(1))
	BLOAD "system\contact.dat", VARPTR(liste(1))
	DEF SEG
	END IF
RETURN
SaveFile:

	DEF SEG = VARSEG(liste(1))
	BSAVE "system\contact.dat", VARPTR(liste(1)), NbrContact * (VARPTR(liste(2)) - VARPTR(liste(1)))
	DEF SEG
RETURN

