
DECLARE SUB TextProgress (message$, value%)
DECLARE SUB CheckNet ()
DECLARE SUB DriveDetect ()

DECLARE FUNCTION DriveExist! (drive AS STRING)
DECLARE FUNCTION CurrentDir$ ()
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\locale.bi'
DIM SHARED rep AS INTEGER
ON ERROR GOTO catch

CLS
TextProgress Localize("live.str", "txtLoginCheck"), 10
CheckNet
SLEEP 1

IF VAL(RegRead("Network:Enabled")) = 1 THEN
TextProgress Localize("live.str", "txtLoginStart"), 20
pseudo$ = RegRead("live:pseudo")
password$ = RegRead("live:password")
IF pseudo$ = "" OR password$ = "" THEN
        PRINT Localize("live.str", "txtLoginSkipping")
ELSE
        
        IF net.login(pseudo$, password$) THEN
                COLOR 10
                PRINT Localize("live.str", "txtLoginFinish")
        ELSE
                COLOR 12
                PRINT Localize("live.str", "txtLoginFailed")
        END IF
        COLOR 7
END IF
END IF
SLEEP 1



TextProgress Localize("live.str", "txtDrivedetection"), 60
DriveDetect
SLEEP 1

TextProgress Localize("live.str", "txtStartingdesktop"), 100
SLEEP 1
CHAIN "bin\desktop.exe"
END



catch:
        rep = 0
        RESUME NEXT

SUB CheckNet
        SHELL "bin\curl.exe -s " + ServerAdress + "version.txt -o out.tmp"
        rep = -1
        fic = FREEFILE
        OPEN "out.tmp" FOR INPUT AS fic
                INPUT #fic, version$
        CLOSE fic
        
        IF rep = -1 THEN
                KILL "out.tmp"
                t$ = Localize("live.str", "txtNetworkEnabled")
                i = INSTR(t$, "*")
                t$ = LEFT$(t$, i - 1) + version$ + MID$(t$, i + 1)
                PRINT t$
                RegWrite "Network:Enabled", "1"
        ELSE
                PRINT Localize("live.str", "txtNetworkDisabled")
                RegWrite "Network:Enabled", "0"
        END IF
END SUB

FUNCTION CurrentDir$
        SHELL "cd >curdir.tmp"
        fic = FREEFILE
        OPEN "curdir.tmp" FOR INPUT AS fic
                INPUT #fic, c$
        CLOSE fic
        KILL "curdir.tmp"

        CurrentDir$ = c$

END FUNCTION

SUB DriveDetect
        NbrDrive = 0
        IF DriveExist("A") THEN
                NbrDrive = NbrDrive + 1
                RegWrite "System:NbrDrives", STR$(NbrDrive)
                RegWrite "System:Drive" + LTRIM$(RTRIM$(STR$(NbrDrive))), "a"
                PRINT "A: ";
        END IF
        IF DriveExist("b") THEN
                NbrDrive = NbrDrive + 1
                RegWrite "System:NbrDrives", STR$(NbrDrive)
                RegWrite "System:Drive" + LTRIM$(RTRIM$(STR$(NbrDrive))), "a"
                PRINT "B: ";
        END IF
        FOR i = ASC("C") TO ASC("Z")
                IF DriveExist(CHR$(i)) THEN
                        NbrDrive = NbrDrive + 1
                        RegWrite "System:NbrDrives", STR$(NbrDrive)
                        RegWrite "System:Drive" + LTRIM$(RTRIM$(STR$(NbrDrive))), CHR$(i)
                        PRINT CHR$(i) + ": ";
                ELSE
                        EXIT FOR
                END IF
        NEXT

        PRINT Localize("live.str", "txtDrivesfound") + STR$(NbrDrive)
END SUB

FUNCTION DriveExist (drive AS STRING)
        rndfile$ = LTRIM$(STR$(INT(TIMER)))
        fic = FREEFILE
        rep = -1
        OPEN drive + ":\" + rndfile$ FOR OUTPUT AS fic
        IF rep THEN
        CLOSE fic
        KILL drive + ":\" + rndfile$
        END IF
        DriveExist = rep

END FUNCTION

SUB TextProgress (message$, value%)
        max% = 80
        longueur% = (value% / 100) * max%
        mystr$ = STRING$(longueur%, 219) + STRING$(max% - longueur%, "|")
        LOCATE 23, 1
        PRINT message$ + SPACE$(max% - LEN(message$));
        LOCATE 24, 1
        PRINT mystr$;
        LOCATE 23, LEN(message$) + 2
END SUB

