DECLARE SUB SendMailDlg (txt AS STRING, Destin AS STRING, Subject AS STRING)
DECLARE SUB GetMail (num AS INTEGER)
DECLARE FUNCTION UserSelectDlg$ ()
DECLARE SUB MouseShow ()
DECLARE SUB MouseHide ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\xTextBox.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\locale.bi'

DECLARE SUB MailList ()
DECLARE SUB LoadUsersList ()


IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	GUI.Init
	MouseShow
	Alert (Localize("System.str", "txtNetworkNotEnabled"))
	app.exit
END IF



DIM SHARED SessionID AS STRING

SessionID = RegRead("Live:SessionID")
IF SessionID = "" THEN
	App.Exec ("bin\login.exe bin\mail.exe")
END IF

'$DYNAMIC
DIM SHARED PostData(1 TO 4) AS STRING
DIM SHARED UsersData(1 TO 1) AS ListItem
DIM SHARED UserList AS ItemList
DIM SHARED NbrUsers AS INTEGER

DIM SHARED MsgContentBox AS MultiLine
DIM SHARED MsgList AS ItemList
DIM SHARED MsgListData(1 TO 20) AS ListItem
DIM SHARED NbrMails AS INTEGER

DIM SHARED NewMailBtn AS button
DIM SHARED RefreshBtn AS button
DIM SHARED ReplyBtn AS button
DIM SHARED MailFrom AS STRING
DIM SHARED MailSubject AS STRING

LoadUsersList
App.SetTitle (Localize("mail.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtLogout"))
App.AddMenuItem (Localize("system.str", "txtExit"))


DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED MsgContent AS STRING
wx = 600
wy = 440
wx1 = (640 - wx) \ 2: wx2 = wx1 + wx
wy1 = (480 - wy) \ 2: wy2 = wy1 + wy
Initx.Button NewMailBtn, Localize("mail.str", "txtButtonNew"), wx1 + 20, wy1 + 50, wx1 + 115, wy1 + 70
Initx.Button RefreshBtn, Localize("mail.str", "txtButtonRefresh"), wx1 + 20, wy1 + 75, wx1 + 115, wy1 + 95
Initx.Button ReplyBtn, Localize("mail.str", "txtButtonReply"), wx1 + 135, wy1 + 215, wx1 + 200, wy1 + 235


Init.MultiLine MsgContentBox, wx1 + 135, wy1 + 240, 55, 24
Init.ItemLIst MsgList, wx1 + 135, wy1 + 35, 1, 15
MsgList.MinWidth = 56
MsgList.MaxWidth = 56
MsgContentBox.Readonly = -1
GUI.Init
MailList

App.DrawGui
Draw.Window wx1, wy1, wx2, wy2, Localize("mail.str", "txtTitle")
Draw.Window wx1 + 10, wy1 + 25, wx1 + 125, wy1 + 110, Localize("mail.str", "txtToolboxTitle")
Draw.MUltiLIne MsgContentBox, MsgContent
IF NbrMails > 0 THEN Draw.ItemList MsgList, MsgListData()
Draw.Button NewMailBtn
Draw.Button RefreshBtn
Draw.Button ReplyBtn
MouseShow

DO
	IF NbrMails > 0 THEN
		Manage.ItemList MsgList, MsgListData()
		IF MsgList.SelectionChanged THEN
			GetMail MsgList.SelectedIndex
			Draw.MUltiLIne MsgContentBox, MsgContent
		END IF
	END IF
	IF Click.Button(RefreshBtn) THEN
		MailList
		IF NbrMails > 0 THEN Draw.ItemList MsgList, MsgListData()
	END IF
	IF Click.Button(NewMailBtn) THEN
		SendMailDlg "", "", ""
	END IF
	App.Manage
	IF LEN(MsgContent) > 0 THEN
		Manage.MultiLIne MsgContentBox, MsgContent
		
		IF Click.Button(ReplyBtn) THEN
		   SendMailDlg CHR$(13) + CHR$(10) + STRING$(20, "-") + CHR$(13) + CHR$(10) + MsgContent, MailFrom, "Re: " + MailSubject
		END IF
	END IF
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu

		CASE "Exit":
			app.exit
		CASE Localize("system.str", "txtExit")
			app.exit
		CASE Localize("system.str", "txtLogout")
		       PostData(1) = ""
		       Net.DownloadPageSession ServerAdress + "/logout.php", "out.tmp", PostData()
		       fic = FREEFILE
		       KILL "out.tmp"
		       RegWrite "Live:SessionID", ""
		       App.Exec ("bin\login.exe bin\mail.exe")
	       
	END SELECT
	END IF
LOOP

REM $STATIC
SUB GetMail (num AS INTEGER)
		       PostData(1) = "action=getmail"
		       PostData(2) = "num=" + LTRIM$(RTRIM$(STR$(NbrMails - (num))))
		       PostData(3) = ""

		       Net.DownloadPageSession ServerAdress + "mail.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, rep
				IF (rep <> 0) THEN
				INPUT #fic, MailFrom
				INPUT #fic, MailSubject

				MsgContent = Localize("mail.str", "txtFrom") + MailFrom + CHR$(13) + CHR$(10)
				MsgContent = MsgContent + Localize("mail.str", "txtSubject") + MailSubject + CHR$(13) + CHR$(13) + CHR$(10)
				WHILE NOT EOF(fic)
				LINE INPUT #fic, t$
				MsgContent = MsgContent + CHR$(13) + t$
				WEND
				ELSE
				MailFrom = ""
				MailSubject = ""
				MsgContent = ""
				END IF
		       CLOSE fic
		       KILL "out.tmp"
		       MouseShow

END SUB

SUB LoadUsersList

		       PostData(1) = ""
		       Net.DownloadPageSessionNoScreen ServerAdress + "liveuser.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, NbrUsers
				NbrUsers = NbrUsers - 1
				IF NbrUsers > 0 THEN
					REDIM UsersData(1 TO NbrUsers) AS ListItem
					FOR i = 1 TO NbrUsers
						INPUT #fic, UsersData(i).text
						UsersData(i).Selected = 0
					NEXT i
					UsersData(1).Selected = -1
				       
				ELSE
					ERASE UsersData
					CLOSE fic
					KILL "out.tmp"
					EXIT SUB
				END IF
		       CLOSE fic
		       KILL "out.tmp"

END SUB

SUB MailList
		      
		       PostData(1) = "action=msglist"
		       PostData(2) = ""
		       Net.DownloadPageSession ServerAdress + "mail.php", "out.tmp", PostData()
		       fic = FREEFILE
		       OPEN "out.tmp" FOR INPUT AS fic
				INPUT #fic, NbrMails
				IF NbrMails > 0 THEN
					REDIM MsgListData(1 TO NbrMails) AS ListItem
					FOR i = 1 TO NbrMails
						INPUT #fic, from$
						INPUT #fic, Subject$
						INPUT #fic, new$

						t$ = from$ + " - " + Subject$
						IF LTRIM$(RTRIM$(new$)) = "1" THEN t$ = Localize("mail.str", "txtNew") + t$
						MsgListData(i).text = t$
						MsgListData(i).Selected = 0
					NEXT i
				ELSE
					ERASE MsgListData
				END IF
		       CLOSE fic
		       KILL "out.tmp"
		       MouseShow

END SUB

DEFINT A-Z
SUB SendMailDlg (txt AS STRING, Destin AS STRING, Subject AS STRING)
	       mx = 320
	       my = 280
	       mx1 = (640 - mx) \ 2: mx2 = mx1 + mx
	       my1 = (480 - my) \ 2: my2 = my1 + my
	       DIM SendBtn AS button
	       DIM CancelBtn AS button
	       DIM ToBtn AS button
	       DIM ToTxt AS TextBox
	       DIM SubjectTxt AS TextBox
	       DIM ContentTxtBox AS MultiLine
	       DIM ContentTxt AS STRING: ContentTxt = txt

	       Initx.Button SendBtn, Localize("mail.str", "txtButtonSend"), mx2 - 100, my2 - 25, mx2 - 10, my2 - 10
	       Initx.Button CancelBtn, Localize("system.str", "txtCancel"), mx2 - 200, my2 - 25, mx2 - 110, my2 - 10
	       Initx.Button ToBtn, Localize("mail.str", "txtTo"), mx1 + 10, my1 + 25, mx1 + 70, my1 + 40
	       Init.TextBox ToTxt, mx1 + 80, my1 + 27, 25
	       ToTxt.text = Destin
	       ToTxt.textlen = LEN(Destin)
	       Init.TextBox SubjectTxt, mx1 + 80, my1 + 47, 25
	       Init.MultiLine ContentTxtBox, mx1 + 10, my1 + 70, 35, 20
	       SubjectTxt.text = Subject
	       SubjectTxt.textlen = LEN(Subject)
	       MouseHide
	       SaveScreen "mail"
	       Draw.Window mx1, my1, mx2, my2, Localize("mail.str", "txtComposeTitle")
	       Draw.Button SendBtn
	       Draw.Button CancelBtn
	       Draw.Button ToBtn
	       Draw.TextBox ToTxt
	       Draw.Text Localize("mail.str", "txtComposeSubject"), mx1 + 10, my1 + 49, TextColor, BgColor
	       Draw.TextBox SubjectTxt
	       Draw.MUltiLIne ContentTxtBox, ContentTxt
	       MouseShow

	       DO
		Manage.MultiLIne ContentTxtBox, ContentTxt
		Manage.TextBox SubjectTxt
		IF Click.Button(CancelBtn) THEN
			EXIT DO
		END IF
		IF Click.Button(ToBtn) THEN
			a$ = UserSelectDlg
			IF a$ <> "" THEN
				ToTxt.text = LTRIM$(RTRIM$(a$))
				ToTxt.textlen = LEN(LTRIM$(RTRIM$(a$)))
				Draw.TextBox ToTxt
			END IF
		END IF
		IF (ToTxt.textlen > 0) AND (SubjectTxt.textlen > 0) AND (LEN(ContentTxt) > 0) THEN
		IF Click.Button(SendBtn) THEN
			num$ = LTRIM$(RTRIM$(STR$(INT(TIMER))))
			SCREEN 0
			WIDTH 80, 25
			fic = FREEFILE
			OPEN "url.txt" FOR OUTPUT AS fic
			PRINT #fic, "url=" + CHR$(34) + ServerAdress + "mail.php" + CHR$(34)
			PRINT #fic, "form " + CHR$(34) + "action=sendmail" + CHR$(34)
			PRINT #fic, "form " + CHR$(34) + "session=" + SessionID + CHR$(34)
			PRINT #fic, "form " + CHR$(34) + "to=" + LEFT$(ToTxt.text, ToTxt.textlen) + CHR$(34)
			PRINT #fic, "form " + CHR$(34) + "subject=" + LEFT$(SubjectTxt.text, SubjectTxt.textlen) + CHR$(34)
			PRINT #fic, "form " + CHR$(34) + "content=" + StrEncode(LTRIM$(RTRIM$(ContentTxt))) + CHR$(34)
		       
			CLOSE fic
			retriever$ = "@bin\curl.exe -K url.txt -s -o out.tmp"
			OPEN "cmdline.bat" FOR OUTPUT AS fic
			PRINT #fic, retriever$
			CLOSE fic
			SHELL "cmdline.bat"
			KILL "cmdline.bat"
			KILL "url.txt"
			
			SCREEN 12
			MouseShow
			EXIT DO
		END IF
		END IF
		LOOP
		
	       RestoreScreen "mail"
END SUB

FUNCTION UserSelectDlg$

       ux = 185
       uy = 130
       ux1 = (640 - ux) \ 2: ux2 = ux1 + ux
       uy1 = (480 - uy) \ 2: uy2 = uy1 + uy
       DIM OkBtn AS button
       DIM CancelBtn AS button
       Initx.Button OkBtn, Localize("system.str", "txtOk"), ux1 + 10, uy2 - 25, ux1 + 90, uy2 - 10
       Initx.Button CancelBtn, Localize("system.str", "txtCancel"), ux2 - 90, uy2 - 25, ux2 - 10, uy2 - 10
       IF NbrUsers > 0 THEN
       Init.ItemLIst UserList, ux1 + 10, uy1 + 35, 1, 5
       UserList.MinWidth = 20
       UserList.MaxWidth = 20
       UserList.SelectedIndex = 1
       UserList.SelectedText = UsersData(1).text
       END IF
       SaveScreen ("ulist")
       Draw.Window ux1, uy1, ux2, uy2, Localize("mail.str", "txtUserselInstruction")
       IF NbrUsers > 0 THEN Draw.ItemList UserList, UsersData()
       Draw.Button OkBtn
       Draw.Button CancelBtn
       MouseShow
	DO
		a$ = INKEY$
		IF Click.Button(OkBtn) OR (a$ = CHR$(13)) THEN
			UserSelectDlg$ = LTRIM$(RTRIM$(UserList.SelectedText))
			EXIT DO
		END IF
		IF Click.Button(CancelBtn) OR (a$ = CHR$(27)) THEN
			UserSelectDlg$ = ""
			EXIT DO
		END IF
		IF NbrUsers > 0 THEN
		Manage.ItemList UserList, UsersData()
		END IF
	LOOP
	RestoreScreen ("ulist")
	ERASE UsersData
END FUNCTION

