DECLARE SUB Draw.KeyBoardNote (no AS INTEGER, o AS INTEGER, h AS INTEGER)
DECLARE SUB ShowGraph ()
DECLARE FUNCTION ImportFms% (fichier AS STRING)
DECLARE SUB ImportFmiFile (Instrum AS ANY, fichier AS STRING)
DECLARE FUNCTION OpenFile! (filename$)
DECLARE SUB SaveFile (filename$)
DECLARE SUB Record ()
DECLARE SUB ImportFmi (Instrum AS ANY)
DECLARE SUB Draw.Control ()
DECLARE SUB Manage.COntrol ()
DECLARE SUB NewFile ()
DECLARE SUB Draw.Note (n AS ANY)
DECLARE SUB Manage.Keyboard ()
DECLARE SUB GetLastNote ()
DECLARE SUB Draw.KeyBOard ()
DECLARE SUB StopAllChanels ()
DECLARE SUB PlayAll ()
DECLARE SUB Save.InsEdit (num%)
DECLARE SUB Load.InsEdit (num AS INTEGER)
DECLARE SUB Start.InsEdit (num AS INTEGER)
DECLARE SUB PlayNote (chan%, note%, Octave%)
DECLARE SUB ResetChan (chan AS INTEGER)
DECLARE SUB setinstrument (channel%, ins AS ANY)
DECLARE SUB Draw.Chanel (num AS INTEGER, drawframe AS INTEGER)
DECLARE SUB Draw.BoxText (xpos AS INTEGER, ypos AS INTEGER, wid AS INTEGER, hei AS INTEGER, col AS INTEGER)
DECLARE SUB Draw.Chanels (frame AS INTEGER)
DECLARE SUB NewChanel ()
DECLARE SUB Manage.InsEdit ()
DECLARE SUB Manage.TrackBar (this AS ANY)
DECLARE SUB Init.TrackBar (this AS ANY, MInVal AS INTEGER, MaxVal AS INTEGER, x1 AS INTEGER, y1 AS INTEGER)
DECLARE SUB Draw.TrackBar (this AS ANY)
DECLARE SUB Draw.InsEdit ()
DECLARE SUB writereg (reg%, info%)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\itemlist.bi'

'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\shelf.bi'

'$INCLUDE: 'srcs\audtrack.str'

TYPE TrackBar
	Value AS INTEGER
	MInVal AS INTEGER
	MaxVal AS INTEGER
	x1 AS INTEGER
	y1 AS INTEGER
	x2 AS INTEGER
	y2 AS INTEGER
	upbtn AS button
	DwBtn AS button
	ValueChanged AS INTEGER
	StepValue AS INTEGER
END TYPE



TYPE MusicHeader
	Format AS STRING * 4
	Version AS INTEGER
	ChanelCount AS INTEGER
	NbrNotes AS INTEGER
	Tempo AS INTEGER
END TYPE
'le type instrument
TYPE Instrument
	attack1 AS INTEGER
	attack2 AS INTEGER

	decay1 AS INTEGER
	decay2 AS INTEGER

	sustain1 AS INTEGER
	sustain2 AS INTEGER

	released1 AS INTEGER
	released2 AS INTEGER

	outp1 AS INTEGER
	outp2 AS INTEGER


	amplitudevibrato1 AS INTEGER
	amplitudevibrato2 AS INTEGER

	scalling1 AS INTEGER
	scalling2 AS INTEGER

	waveselect1 AS INTEGER
	waveselect2 AS INTEGER

	pitchvibrato1 AS INTEGER
	pitchvibrato2 AS INTEGER

	frequencymultipler1 AS INTEGER
	frequencymultipler2 AS INTEGER

	enveloppescalling1 AS INTEGER
	enveloppescalling2 AS INTEGER


	sustaininglevel1 AS INTEGER
	sustaininglevel2 AS INTEGER

	feedback AS INTEGER
	connection AS INTEGER
	iname AS STRING * 8
    
END TYPE

TYPE Chanel
	Instrument AS Instrument
	Enabled AS INTEGER
END TYPE

TYPE note
	num AS INTEGER
	Octave AS INTEGER
END TYPE

'Notes frequency
DIM SHARED notef(0 TO 11) AS INTEGER
DIM SHARED LastNote AS INTEGER
notef(0) = &H16B: notef(1) = &H181: notef(2) = &H198
notef(3) = &H1B0: notef(4) = &H1CA: notef(5) = &H1E5
notef(6) = &H202: notef(7) = &H220: notef(8) = &H241
notef(9) = &H263: notef(10) = &H287: notef(11) = &H2AE

DIM SHARED ix1 AS INTEGER, iy1 AS INTEGER, ix2 AS INTEGER, iy2 AS INTEGER
DIM SHARED AtackTrack(1 TO 2) AS TrackBar
DIM SHARED DecayTrack(1 TO 2) AS TrackBar
DIM SHARED SustainTrack(1 TO 2) AS TrackBar
DIM SHARED ReleaseTrack(1 TO 2) AS TrackBar
DIM SHARED OutLevelTrack(1 TO 2) AS TrackBar
DIM SHARED LevelScall(1 TO 2) AS TrackBar
DIM SHARED FreqMult(1 TO 2) AS TrackBar
DIM SHARED CloseBtn AS button
DIM SHARED VibratoAmp(1 TO 2) AS ListItem
DIM SHARED VibratoAmpList AS ItemList
DIM SHARED VibratoPitch(1 TO 2) AS ListItem
DIM SHARED VibratoPitchList AS ItemList
DIM SHARED scalling(1 TO 2) AS ListItem
DIM SHARED ScallingList AS ItemList
DIM SHARED sustain(1 TO 2) AS ListItem
DIM SHARED SustainList AS ItemList
DIM SHARED WaveSelectList(1 TO 2) AS ItemList
DIM SHARED waveselect1(0 TO 3) AS ListItem
DIM SHARED waveselect2(0 TO 3) AS ListItem
DIM SHARED feedback AS TrackBar
DIM SHARED ConnectionList AS ItemList
DIM SHARED connection(1 TO 1) AS ListItem
DIM SHARED FmiBtn AS button
DIM SHARED RecordBtn AS button
CONST MaxNotes = 1000
DIM SHARED Notes(1 TO 8, 0 TO MaxNotes) AS note
DIM SHARED Chanels(1 TO 8) AS Chanel
DIM SHARED FIleHeader AS MusicHeader
DIM SHARED SelectedChanel AS INTEGER
DIM SHARED NbrChanel AS INTEGER
DIM SHARED SelectedOctave AS INTEGER
DIM SHARED IsDiese AS INTEGER
DIM SHARED InsButton(1 TO 8) AS button
DIM SHARED PositionCurseur AS INTEGER
DIM SHARED PlayBtn AS button
DIM SHARED TempoTrack AS TrackBar
DIM SHARED OctaveTrack AS TrackBar
DIM SHARED Recording AS INTEGER


DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
wx1 = 20: wy1 = 35: wx2 = 620: wy2 = 230


App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuNew)
App.AddMenuItem (txtMenuOpen)
App.AddMenuItem (txtMenuSave)
App.AddMenuItem (txtMenuSaveas)
IF VAL(RegRead("Network:Enabled")) = 1 THEN
SessionID$ = RegRead("Live:SessionID")
IF SessionID$ <> "" THEN
       App.AddMenuItem (txtMenuLiveopen)
       App.AddMenuItem (txtMenuLivesave)
END IF
END IF
App.AddMenuItem (txtMenuImportfms)
App.AddMenuItem (txtMenuGraph)
App.AddMenuItem (txtMenuExit)

NewFile
GUI.Init
App.DrawGui
GOSUB DrawAll
Draw.KeyBOard
Shelf.Load
Shelf.Draw
MouseShow

DO
	Manage.COntrol
	a$ = INKEY$
	IF a$ <> "" THEN
		aok = 0
		FOR i% = 1 TO 8
			IF a$ = CHR$(0) + CHR$(i% + 58) THEN
				Chanels(i%).Enabled = NOT Chanels(i%).Enabled
				Draw.Chanel i%, -1
			END IF
		NEXT i%
		IF a$ = CHR$(0) + CHR$(72) AND PositionCurseur > 0 THEN
			GetLastNote
			PositionCurseur = PositionCurseur - 1
			IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
			Draw.Chanels 0
		END IF
		IF a$ = CHR$(0) + CHR$(80) AND PositionCurseur < MaxNotes THEN
			GetLastNote
			PositionCurseur = PositionCurseur + 1
			IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
			Draw.Chanels 0
		END IF
		IF a$ = CHR$(0) + CHR$(75) AND SelectedChanel > 1 THEN
			SelectedChanel = SelectedChanel - 1
			Draw.Chanels 1
		END IF

		IF a$ = CHR$(0) + CHR$(77) AND SelectedChanel < NbrChanel THEN
			SelectedChanel = SelectedChanel + 1
			Draw.Chanels 1
		END IF


		IF a$ = " " THEN
			Notes(SelectedChanel, PositionCurseur).num = -2
			IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
			GetLastNote
			IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
			Draw.Chanels 0
			
		END IF

		IF LCASE$(a$) = "x" THEN
			Notes(SelectedChanel, PositionCurseur).num = -1
			GetLastNote
			IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
			IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
			Draw.Chanels 0
		END IF

		SELECT CASE LCASE$(a$)
			CASE "+":
				IF SelectedOctave < 5 THEN SelectedOctave = SelectedOctave + 1
					OctaveTrack.Value = SelectedOctave
					Draw.TrackBar OctaveTrack
			CASE "-":
				IF SelectedOctave > 0 THEN SelectedOctave = SelectedOctave - 1
					OctaveTrack.Value = SelectedOctave
					Draw.TrackBar OctaveTrack

			CASE "#":
				IsDiese = NOT IsDiese

				
			CASE "c":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 0 + ABS(IsDiese)
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "d":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 2 + ABS(IsDiese)
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "e":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 4
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "f":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 5 + ABS(IsDiese)
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "g":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 7 + ABS(IsDiese)
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "a":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 9 + ABS(IsDiese)
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0

			CASE "b":
				aok = -1
				Notes(SelectedChanel, PositionCurseur).num = 11
				Notes(SelectedChanel, PositionCurseur).Octave = SelectedOctave
				Draw.Note Notes(SelectedChanel, PositionCurseur)
				GetLastNote
				IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + 1
				IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
				Draw.Chanels 0
			CASE CHR$(8):
				IF PositionCurseur > 0 THEN PositionCurseur = PositionCurseur - 1
					Notes(SelectedChanel, PositionCurseur).num = -2
					GetLastNote
					IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
					Draw.Chanels 0
					
		END SELECT
		IF aok = -1 THEN
			DO: LOOP UNTIL INP(&H60) > 128
			DO: LOOP UNTIL INKEY$ = ""
			Draw.KeyBOard
		END IF
	END IF

	App.ManageKey a$
	SELECT CASE SelectedMenu
		CASE txtMenuNew
			GOSUB SubNewFile
		CASE txtMenuSave:
			GOSUB SubSaveFile
		CASE txtMenuSaveas:
			GOSUB SubSaveFileAs
		CASE txtMenuOpen:
			GOSUB SubOpenFile
		CASE txtMenuExit:
			app.Exit
		CASE txtMenuImportfms:
			GOSUB subImportFms
		CASE txtMenuGraph:
			ShowGraph
		'internet file system
		CASE txtMenuLiveopen
			fichier$ = NetFileSelect("open")
			IF fichier$ <> "" THEN
			   IF OpenFile("outdoc.tmp") THEN
				OpenedFile$ = ""
				GOSUB DrawAll
			   END IF
			   KILL "outdoc.tmp"
			END IF
		CASE txtMenuLivesave
			SaveFile "indoc.tmp"
			fichier$ = NetFileSelect("save")
			OpenedFile$ = ""
      

	END SELECT
	Manage.Keyboard

	IF Shelf.Drag THEN GOSUB SubShelfDrag
LOOP


SubShelfDrag:
	fichier$ = LCASE$(Shelf.Selected)
	IF RIGHT$(fichier$, 4) = ".fmi" THEN
		FOR num% = 1 TO NbrChanel
			x1% = wx1 + 15 + (num% - 1) * 72
			y1% = wy1 + 82
			x2% = x1% + 65
			y2% = y1% + 83
			IF MouseZOne(x1%, y1%, x2%, y2%) THEN
				ImportFmiFile Chanels(num%).Instrument, fichier$
				setinstrument num%, Chanels(num%).Instrument
				t! = TIMER
				PlayNote num%, 0, 3
				DO: LOOP UNTIL TIMER > t! + 1
				ResetChan num%
		       
			END IF
	       
		NEXT
	END IF
       
	IF RIGHT$(fichier$, 4) = ".fmx" THEN
		IF MouseZOne(wx1, wy1, wx2, wy2) THEN
		IF OpenFile(fichier$) THEN
			OpenedFile$ = fichier$
			GOSUB DrawAll
		END IF
		END IF
	END IF
	IF RIGHT$(fichier$, 4) = ".fms" THEN
		IF MouseZOne(wx1, wy1, wx2, wy2) THEN
		IF ImportFms(fichier$) THEN
			OpenedFile$ = ""
			GOSUB DrawAll
		 END IF
		END IF
	END IF
RETURN

SubNewFile:
	OpenedFile$ = ""
	NewFile
	GOSUB DrawAll
RETURN

subImportFms:
	fichier$ = FileSelect("open", "", "fms document=yes")
	IF fichier$ <> "" THEN
		IF ImportFms("outdoc.tmp") THEN
			OpenedFile$ = ""
			GOSUB DrawAll
		END IF
		KILL "outdoc.tmp"
	END IF
	Shelf.Load
	Shelf.Draw

RETURN

SubOpenFile:
	fichier$ = FileSelect(txtMenuOpen, "", "fmx document=yes")
       
	IF fichier$ <> "" THEN
		IF OpenFile("outdoc.tmp") THEN
			OpenedFile$ = fichier$
			GOSUB DrawAll
		END IF
		KILL "outdoc.tmp"
	END IF
	Shelf.Load
	Shelf.Draw

RETURN

SubSaveFile:
	IF OpenedFile$ <> "" THEN
		SaveFile (OpenedFile$)
	ELSE
		GOTO SubSaveFileAs
	END IF
RETURN

SubSaveFileAs:
	SaveFile "indoc.tmp"
	fichier$ = FileSelect(txtMenuSave, "", "fmx document=yes")
	IF fichier$ <> "" THEN OpenedFile$ = fichier$
	Shelf.Load
	Shelf.Draw
RETURN

DrawAll:
	Draw.Chanels -1
	Draw.Control
	
	
RETURN

SUB Draw.BoxText (xpos AS INTEGER, ypos AS INTEGER, wid AS INTEGER, hei AS INTEGER, col AS INTEGER)
	lignetop$ = CHR$(218) + STRING$(wid - 2, CHR$(196)) + CHR$(191)
	lignemiddle$ = CHR$(179) + STRING$(wid - 2, " ") + CHR$(179)
	lignebottom$ = CHR$(192) + STRING$(wid - 2, CHR$(196)) + CHR$(217)
	LOCATE ypos, xpos
	COLOR col
	PRINT lignetop$
	FOR i = 2 TO hei - 1
		LOCATE ypos + i - 1, xpos
		PRINT lignemiddle$
	NEXT i
	LOCATE ypos + hei - 1, xpos
	PRINT lignebottom$

END SUB

SUB Draw.Chanel (num AS INTEGER, drawframe AS INTEGER)
	IF num < 0 OR num > 8 THEN EXIT SUB
	MouseHide



'----- LES CHAINES
	IF drawframe THEN
	IF SelectedChanel <> num THEN
		Draw.BoxText 5 + (num - 1) * 9, 8, 9, 6, 15
	ELSE
		Draw.BoxText 5 + (num - 1) * 9, 8, 9, 6, 14
	END IF
	z$ = "  F" + RIGHT$(STR$(i), 1)
	IF NOT Chanels(num).Enabled THEN
		z$ = z$ + " OO  "
	ELSE
		z$ = z$ + " __  "
	END IF
      
	LOCATE 7, 5 + (num - 1) * 9
	COLOR 15
	PRINT z$
	END IF

nstr$ = "CDEFGAB"


      

Debut = PositionCurseur - 3
IF Debut < 0 THEN Debut = 0
fin = Debut + 3
IF fin > MaxNotes THEN fin = MaxNotes: Debut = MaxNotes - 3

FOR P = Debut TO fin
	 SELECT CASE Notes(num, P).num
		CASE -1: d$ = "XXX"
		CASE -2: d$ = "___"
		CASE 0: d$ = " C" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 1: d$ = "#C" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 2: d$ = " D" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 3: d$ = "#D" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 4: d$ = " E" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 5: d$ = " F" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 6: d$ = "#F" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 7: d$ = " G" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 8: d$ = "#G" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 9: d$ = " A" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 10: d$ = "#A" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
		CASE 11: d$ = " B" + LTRIM$(RTRIM$(STR$(Notes(num, P).Octave)))
	 END SELECT
	 

	IF SelectedChanel = num THEN
			IF P = PositionCurseur THEN
				fgcol% = 14
			ELSE
				fgcol% = 7
			END IF
	ELSE
			fgcol% = 7
       END IF
	a$ = STRING$(3 - LEN(HEX$(P)), "0") + HEX$(P) + " " + d$
	LOCATE 9 + (P - Debut), 6 + (num - 1) * 9
	COLOR fgcol%
	PRINT a$
NEXT




		 MouseShow

END SUB

DEFINT A-Z
SUB Draw.Chanels (frame AS INTEGER)
IF frame THEN
	Draw.Window wx1, wy1, wx2, wy2, txtNoteeditTitle
END IF
       Draw.Text STR$(PositionCurseur) + "/" + STR$(LastNote) + "    ", 25, 55, TextColor, BGColor
       FOR i = 1 TO NbrChanel
	Draw.Chanel i, frame
	bx1% = ((i - 1) * 72) + 35
	by1% = 210
	bx2% = bx1% + 65
	by2% = 225
	IF frame THEN
	Initx.Button InsButton(i), "Instr.", bx1%, by1%, bx2%, by2%
	Draw.Button InsButton(i)
	END IF
       NEXT i
END SUB

SUB Draw.Control
	cx1 = 20
	cx2 = 620
	cy1 = 270
	cy2 = 360
	Draw.Frame cx1, cy1, cx2, cy2
	Draw.Text txtCtrlTempo, cx1 + 5, cy1 + 40, TextColor, -1
	Draw.Text txtCtrlOctave, cx1 + 5, cy1 + 60, TextColor, -1
	Draw.Text txtCtrlHelp1, cx1 + 150, cy1 + 12, TextColor, -1
	Draw.Text txtCtrlHelp2, cx1 + 150, cy1 + 22, TextColor, -1
	Draw.Text txtCtrlHelp3, cx1 + 150, cy1 + 32, TextColor, -1
	Draw.Text txtCtrlHelp4, cx1 + 150, cy1 + 62, TextColor, -1
	Initx.Button PlayBtn, txtCtrlPlay, cx1 + 5, cy1 + 5, cx1 + 75, cy1 + 20
	Initx.Button RecordBtn, txtCtrlRecord, cx2 - 75, cy1 + 5, cx2 - 5, cy1 + 25
	Draw.Button PlayBtn
	Init.TrackBar TempoTrack, 40, 360, cx1 + 70, cy1 + 40
	Init.TrackBar OctaveTrack, 0, 5, cx1 + 70, cy1 + 60
	TempoTrack.StepValue = 10
	TempoTrack.Value = FIleHeader.Tempo
	OctaveTrack.Value = SelectedOctave
	Draw.TrackBar TempoTrack
	Draw.TrackBar OctaveTrack
'        Draw.Button RecordBtn
END SUB

DEFSNG A-Z
SUB Draw.InsEdit
	MouseHide
	Draw.Window ix1, iy1 - 15, ix2, iy2, txtInsTitle
	Draw.Text txtInsHeading, ix1 + 200, iy1 + 5, TextColor, -1
	Draw.Text txtInsAttack, ix1 + 5, iy1 + 19, TextColor, -1
	Draw.Text txtInsDecay, ix1 + 5, iy1 + 34, TextColor, -1
	Draw.Text txtInsSustain, ix1 + 5, iy1 + 49, TextColor, -1
	Draw.Text txtInsRelease, ix1 + 5, iy1 + 64, TextColor, -1
	Draw.Text txtInsOutlev, ix1 + 5, iy1 + 79, TextColor, -1
	Draw.Text txtInsLevsca, ix1 + 5, iy1 + 94, TextColor, -1
	Draw.Text txtInsVibamp, ix1 + 5, iy1 + 109, TextColor, -1
	Draw.Text txtInsPtcvib, ix1 + 5, iy1 + 124, TextColor, -1
	Draw.Text txtInsFrqmul, ix1 + 5, iy1 + 139, TextColor, -1
	Draw.Text txtInsEnvsca, ix1 + 5, iy1 + 154, TextColor, -1
	Draw.Text txtInsSuslev, ix1 + 5, iy1 + 169, TextColor, -1
	Draw.Text txtInsWavsel, ix1 + 5, iy1 + 184, TextColor, -1
	LINE (ix1 + 5, iy1 + 195)-(ix2 - 5, iy1 + 195), 0
	Draw.Text txtInsFeedback, ix1 + 5, iy1 + 210, TextColor, -1
	Draw.Text txtInsConnection, ix1 + 5, iy1 + 225, TextColor, -1
	Draw.Button CloseBtn

	Draw.TrackBar AtackTrack(1)
	Draw.TrackBar AtackTrack(2)
	Draw.TrackBar DecayTrack(1)
	Draw.TrackBar DecayTrack(2)
	Draw.TrackBar SustainTrack(1)
	Draw.TrackBar SustainTrack(2)
	Draw.TrackBar ReleaseTrack(1)
	Draw.TrackBar ReleaseTrack(2)
	Draw.TrackBar OutLevelTrack(1)
	Draw.TrackBar OutLevelTrack(2)
	Draw.TrackBar LevelScall(1)
	Draw.TrackBar LevelScall(2)
	Draw.TrackBar FreqMult(1)
	Draw.TrackBar FreqMult(2)
	Draw.CheckBoxList VibratoAmpList, VibratoAmp()
	Draw.CheckBoxList VibratoPitchList, VibratoPitch()
	Draw.CheckBoxList ScallingList, scalling()
	Draw.CheckBoxList SustainList, sustain()
	Draw.RadioBUttonList WaveSelectList(1), waveselect1()
	Draw.RadioBUttonList WaveSelectList(2), waveselect2()
	Draw.TrackBar feedback
	Draw.CheckBoxList ConnectionList, connection()
	Draw.Button FmiBtn

	MouseShow

END SUB

SUB Draw.KeyBOard
	LastN = -1
	LastO = -1
	FOR o = 0 TO 5
		FOR n = 0 TO 11
			IF NOT (n = 1 OR n = 3 OR n = 6 OR n = 8 OR n = 10) THEN
				x1 = 25 + (n * 7) + (o * 98)
				IF n > 4 THEN x1 = x1 + 7
				x2 = x1 + 14
				y1 = 400
				y2 = 465
			       
				LINE (x1, y1)-(x2, y2), 15, BF
				LINE (x1, y1)-(x2, y2), 0, B
			END IF
		NEXT n
		FOR n = 0 TO 11
			IF (n = 1 OR n = 3 OR n = 6 OR n = 8 OR n = 10) THEN
				x1 = 25 + (n * 7) + (o * 98) + 3
				IF n > 4 THEN x1 = x1 + 7
				x2 = x1 + 8
				y1 = 400
				y2 = 440
				LINE (x1, y1)-(x2, y2), 0, BF
			END IF

		NEXT n
	NEXT o
       
	
END SUB

SUB Draw.KeyBoardNote (no AS INTEGER, oo AS INTEGER, h AS INTEGER)
	      IF no < 0 THEN EXIT SUB
	      MouseHide
	      n = no
	      o = oo - 1
	      IF NOT (n = 1 OR n = 3 OR n = 6 OR n = 8 OR n = 10) THEN
				x1 = 25 + (n * 7) + (o * 98)
				IF n > 4 THEN x1 = x1 + 7
				x2 = x1 + 14
				y1 = 400
				y2 = 465
				c = ABS(h = -1) * 15 + ABS(h <> -1) * h
				LINE (x1, y1)-(x2, y2), c, BF
				LINE (x1, y1)-(x2, y2), 0, B
				IF n = 0 OR n = 2 OR n = 5 OR n = 7 OR n = 9 THEN
				   n = n + 1
				   x1 = 25 + (n * 7) + (o * 98) + 3
				   IF n > 4 THEN x1 = x1 + 7
				   x2 = x1 + 8
				   y1 = 400
				   y2 = 440
				   LINE (x1, y1)-(x2, y2), 0, BF
				   n = n - 1
				END IF
				IF n = 2 OR n = 4 OR n = 7 OR n = 9 OR n = 11 THEN
				   n = n - 1
				   x1 = 25 + (n * 7) + (o * 98) + 3
				   IF n > 4 THEN x1 = x1 + 7
				   x2 = x1 + 8
				   y1 = 400
				   y2 = 440
				   LINE (x1, y1)-(x2, y2), 0, BF
				   n = n - 1
				END IF
				MouseShow
				EXIT SUB
	     ELSE
				x1 = 25 + (n * 7) + (o * 98) + 3
				IF n > 4 THEN x1 = x1 + 7
				x2 = x1 + 8
				y1 = 400
				y2 = 440
				c = ABS(h = -1) * 0 + ABS(h <> -1) * h
				LINE (x1, y1)-(x2, y2), c, BF
			END IF
MouseShow
END SUB

DEFINT A-Z
SUB Draw.Note (n AS note)
		FOR j = 1 TO NbrChanel
			Draw.Chanel j, 0
			PlayNote j, Notes(j, PositionCurseur).num, Notes(j, PositionCurseur).Octave
		NEXT
		Draw.KeyBoardNote n.num, n.Octave, 9


END SUB

DEFSNG A-Z
SUB Draw.TrackBar (this AS TrackBar)
	MouseHide
	LINE (this.x1, this.y1)-(this.x2, this.y2), 15, BF
	Draw.Button this.upbtn
	Draw.Button this.DwBtn
	a$ = LTRIM$(RTRIM$(STR$(this.Value)))
	ax1% = (this.x2 + this.x1 - LEN(a$) * 8) \ 2
	ay1% = this.y1 + 3
	Draw.Text a$, ax1%, ay1%, 0, 15
	MouseShow
END SUB

SUB GetLastNote
			lz = 0
			FOR y = 1 TO NbrChanel
				FOR z = MaxNotes TO 0 STEP -1
					IF Notes(y, z).num <> -2 THEN EXIT FOR
				NEXT z
				IF (z > lz) THEN lz = z
			NEXT y
			LastNote = lz
END SUB

DEFINT A-Z
SUB ImportFmi (Instrum AS Instrument)
	fichier$ = FileSelect(txtMenuOpen, "", "fmi")
	Shelf.Load
	Shelf.Draw
	IF fichier$ <> "" THEN
OPEN fichier$ FOR INPUT AS #1
INPUT #1, head$
'modifier avec un message BOX
IF head$ <> "fm-song instrument" THEN EXIT SUB

INPUT #1, iname

INPUT #1, Instrum.attack1, Instrum.attack2
INPUT #1, Instrum.decay1, Instrum.decay2
INPUT #1, Instrum.sustain1, Instrum.sustain2
INPUT #1, Instrum.released1, Instrum.released2
INPUT #1, Instrum.outp1, Instrum.outp2
INPUT #1, Instrum.scalling1, Instrum.scalling2

INPUT #1, Instrum.amplitudevibrato1, Instrum.amplitudevibrato2
'INPUT #1, Instrum.levelscalling1, Instrum.levelscalling2
INPUT #1, Instrum.pitchvibrato1, Instrum.pitchvibrato2
INPUT #1, Instrum.frequencymultipler1, Instrum.frequencymultipler2
INPUT #1, Instrum.enveloppescalling1, Instrum.enveloppescalling2
INPUT #1, Instrum.waveselect1, Instrum.waveselect2
INPUT #1, Instrum.sustaininglevel1, Instrum.sustaininglevel2
INPUT #1, Instrum.feedback, Instrum.connection


CLOSE #1
	IF LCASE$(RIGHT$(fichier$, 3)) = ".tmp" THEN KILL fichier$
	END IF
END SUB

DEFSNG A-Z
SUB ImportFmiFile (Instrum AS Instrument, fichier AS STRING)
OPEN fichier$ FOR INPUT AS #1
INPUT #1, head$
'modifier avec un message BOX
IF head$ <> "fm-song instrument" THEN EXIT SUB

INPUT #1, iname

INPUT #1, Instrum.attack1, Instrum.attack2
INPUT #1, Instrum.decay1, Instrum.decay2
INPUT #1, Instrum.sustain1, Instrum.sustain2
INPUT #1, Instrum.released1, Instrum.released2
INPUT #1, Instrum.outp1, Instrum.outp2
INPUT #1, Instrum.scalling1, Instrum.scalling2

INPUT #1, Instrum.amplitudevibrato1, Instrum.amplitudevibrato2
'INPUT #1, Instrum.levelscalling1, Instrum.levelscalling2
INPUT #1, Instrum.pitchvibrato1, Instrum.pitchvibrato2
INPUT #1, Instrum.frequencymultipler1, Instrum.frequencymultipler2
INPUT #1, Instrum.enveloppescalling1, Instrum.enveloppescalling2
INPUT #1, Instrum.waveselect1, Instrum.waveselect2
INPUT #1, Instrum.sustaininglevel1, Instrum.sustaininglevel2
INPUT #1, Instrum.feedback, Instrum.connection


CLOSE #1
END SUB

DEFINT A-Z
FUNCTION ImportFms (fichier AS STRING)

DIM pname AS STRING * 20   'le nom de la musique
DIM Auteur AS STRING * 20   'l'auteur de la musique
DIM Commentaire AS STRING * 50   'le commentaire de la musique
DIM MaxTrack AS INTEGER
DIM trackdelay(1 TO 8) AS INTEGER
DIM MNotes(1 TO 8) AS INTEGER
DIM indexes(1 TO 8) AS INTEGER
NewFile
OPEN fichier$ FOR BINARY AS #1
IF LOF(1) = 0 THEN ImportFms = 0: CLOSE 1: EXIT FUNCTION

'l'entte
SEEK #1, 1
var$ = "               "
GET #1, , var$
IF var$ <> "fm-song-project" THEN ImportFms = 0:  EXIT FUNCTION

'l'auteur
GET #1, , pname
GET #1, , Auteur
GET #1, , Commentaire
GET #1, , MaxTrack

'les instruments
FOR k = 1 TO 8        'les channels
	GET #1, , Chanels(k).Instrument.iname
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.attack1 = ASC(i1$)
		   Chanels(k).Instrument.attack2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.decay1 = ASC(i1$)
		   Chanels(k).Instrument.decay2 = ASC(i2$)
	  
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.sustain1 = ASC(i1$)
		   Chanels(k).Instrument.sustain2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.released1 = ASC(i1$)
		   Chanels(k).Instrument.released2 = ASC(i2$)
	   
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.outp1 = ASC(i1$)
		   Chanels(k).Instrument.outp2 = ASC(i2$)
	   
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.scalling1 = ASC(i1$)
		   Chanels(k).Instrument.scalling2 = ASC(i2$)

	   
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.amplitudevibrato1 = ASC(i1$)
		   Chanels(k).Instrument.amplitudevibrato2 = ASC(i2$)

		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.pitchvibrato1 = ASC(i1$)
		   Chanels(k).Instrument.pitchvibrato2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.frequencymultipler1 = ASC(i1$)
		   Chanels(k).Instrument.frequencymultipler2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.enveloppescalling1 = ASC(i1$)
		   Chanels(k).Instrument.enveloppescalling2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.waveselect1 = ASC(i1$)
		   Chanels(k).Instrument.waveselect2 = ASC(i2$)
	   
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.feedback = ASC(i1$)
		   Chanels(k).Instrument.connection = ASC(i2$)

		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   Chanels(k).Instrument.sustaininglevel1 = ASC(i1$)
		   Chanels(k).Instrument.sustaininglevel2 = ASC(i2$)

'------- fin du chargement de l'instrument
NEXT



'la trac
FOR i = 1 TO 8
	indexes(i) = 0
NEXT

FOR i = 1 TO MaxTrack
	GET #1, , MNotes(i)       'les max notes
	    'il put l'instrument
	GET #1, , trackdelay(i)
	    'find de put instrument
   
	'put les channels dans le fichier
     
	FOR cn = 1 TO 8: sc$ = " ":
		GET #1, , sc$
		Chanels(i).Enabled = (ASC(sc$) <> 0)
	NEXT
		
		FOR k = 1 TO 8
		   FOR j = 0 TO MNotes(i) - 1     'les notes
			
			n1$ = " "
			GET #1, , n1$
			var = ASC(n1$)
			Octave = ((var AND 56) / 8)
			diese = (var AND 64) / 64
			n = (var AND 7)
			SELECT CASE n
				CASE 0: note = -2
				CASE 1: note = 0 + diese
				CASE 2: note = 2 + diese
				CASE 3: note = 4
				CASE 4: note = 5 + diese
				CASE 5: note = 7 + diese
				CASE 6: note = 9 + diese
				CASE 7: note = 11
			END SELECT
			no = (var AND 128) / 128
			IF no = 1 THEN note = -1
			IF indexes(k) <= MaxNotes THEN
			Notes(k, indexes(k)).num = note
			Notes(k, indexes(k)).Octave = Octave
			END IF
			indexes(k) = indexes(k) + 1
		    NEXT
		NEXT
NEXT

CLOSE #1
FOR l = 1 TO 8
	
	setinstrument l, Chanels(l).Instrument
NEXT
	SelectedOctave = 3
	IsDiese = 0
	LastNote = 0
	PositionCurseur = 0
	SelectedChanel = 1
	ImportFms = -1


ERASE trackdelay
ERASE MNotes
ERASE indexes

END FUNCTION

DEFSNG A-Z
SUB Init.TrackBar (this AS TrackBar, MInVal AS INTEGER, MaxVal AS INTEGER, x1 AS INTEGER, y1 AS INTEGER)
	this.MInVal = MInVal
	this.MaxVal = MaxVal
	this.Value = MInVal
	this.x1 = x1
	this.x2 = x1 + (LEN(STR$(this.MaxVal)) - 1) * 8 + 40
	this.y1 = y1
	this.y2 = y1 + 12
	Initx.Button this.upbtn, "+", this.x2 - 12, this.y1, this.x2, this.y2
	Initx.Button this.DwBtn, "-", this.x1, this.y1, this.x1 + 12, this.y2
	this.StepValue = 1
END SUB

SUB Load.InsEdit (num AS INTEGER)
	AtackTrack(1).Value = Chanels(num).Instrument.attack1
	AtackTrack(2).Value = Chanels(num).Instrument.attack2
	DecayTrack(1).Value = Chanels(num).Instrument.decay1
	DecayTrack(2).Value = Chanels(num).Instrument.decay2
	SustainTrack(1).Value = Chanels(num).Instrument.sustain1
	SustainTrack(2).Value = Chanels(num).Instrument.sustain2
	ReleaseTrack(1).Value = Chanels(num).Instrument.released1
	ReleaseTrack(2).Value = Chanels(num).Instrument.released2
	OutLevelTrack(1).Value = Chanels(num).Instrument.outp1
	OutLevelTrack(2).Value = Chanels(num).Instrument.outp2
	LevelScall(1).Value = Chanels(num).Instrument.scalling1
	LevelScall(2).Value = Chanels(num).Instrument.scalling2
	FreqMult(1).Value = Chanels(num).Instrument.frequencymultipler1
	FreqMult(2).Value = Chanels(num).Instrument.frequencymultipler2
	VibratoAmp(1).selected = Chanels(num).Instrument.amplitudevibrato1 <> 0
	VibratoAmp(2).selected = Chanels(num).Instrument.amplitudevibrato2 <> 0
	VibratoPitch(1).selected = Chanels(num).Instrument.pitchvibrato1 <> 0
	VibratoPitch(2).selected = Chanels(num).Instrument.pitchvibrato2 <> 0
	scalling(1).selected = Chanels(num).Instrument.scalling1 <> 0
	scalling(2).selected = Chanels(num).Instrument.scalling2 <> 0
	sustain(1).selected = Chanels(num).Instrument.sustaininglevel1 <> 0
	sustain(2).selected = Chanels(num).Instrument.sustaininglevel2 <> 0
	feedback.Value = Chanels(num).Instrument.feedback
	FOR i = 0 TO 3
		waveselect1(i).selected = (Chanels(num).Instrument.waveselect1 = i)
		waveselect2(i).selected = (Chanels(num).Instrument.waveselect2 = i)
	NEXT i
	WaveSelectList(1).SelectedIndex = Chanels(num).Instrument.waveselect1
	WaveSelectList(2).SelectedIndex = Chanels(num).Instrument.waveselect2
	connection(1).selected = Chanels(num).Instrument.connection <> 0

END SUB

SUB Manage.COntrol
	Manage.TrackBar TempoTrack
	IF Click.Button(PlayBtn) THEN PlayAll
	FOR i% = 1 TO NbrChanel
		IF Click.Button(InsButton(i%)) THEN
			Start.InsEdit i%
		END IF
	NEXT i%
	IF TempoTrack.ValueChanged THEN FIleHeader.Tempo = TempoTrack.Value
'        IF Click.Button(RecordBtn) THEN Record
END SUB

DEFINT A-Z
SUB Manage.Keyboard
       
	FOR o = 1 TO 6
		FOR n = 0 TO 11
			IF (n = 1 OR n = 3 OR n = 6 OR n = 8 OR n = 10) THEN
		       
				x1 = 25 + (n * 7) + ((o - 1) * 98) + 3
				IF n > 4 THEN x1 = x1 + 7
				x2 = x1 + 8
				y1 = 400
				y2 = 440
			ELSE
		      
			x1 = 25 + (n * 7) + ((o - 1) * 98)
			IF n > 4 THEN x1 = x1 + 7
			x2 = x1 + 14
			y1 = 440
			y2 = 465
			END IF
				       
				IF (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft) THEN
					PlayNote SelectedChanel, n, o
					Draw.KeyBoardNote n, o, SelectedChanel
					DO: LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
					Draw.KeyBoardNote n, o, -1
					ResetChan SelectedChanel
					IF MouseZOne(x1, y1, x2, y2) THEN
					
					't2! = TIMER
					'diff! = t2! - t!
					
					NbrNotes = 1'(FIleHeader.Tempo / 15) * diff!
					IF NbrNotes < 1 THEN NbrNotes = 1
						FOR i = 0 TO NbrNotes - 1
							Notes(SelectedChanel, PositionCurseur + i).num = -2
						NEXT i
						Notes(SelectedChanel, PositionCurseur).num = n
						Notes(SelectedChanel, PositionCurseur).Octave = o
					       
						GetLastNote
					       
						IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + NbrNotes
						IF PositionCurseur > MaxNotes THEN PositionCurseur = MaxNotes
						IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
						Draw.Chanels 0
						
					END IF
				END IF
		NEXT n

	NEXT o

	IF MouseClicRight AND NOT MouseZOne(0, 470, 639, 479) THEN
	DO: LOOP UNTIL NOT MouseClicRight
		PositionCurseur = PositionCurseur + 1
		GetLastNote
					      
		IF PositionCurseur < MaxNotes THEN PositionCurseur = PositionCurseur + NbrNotes
		IF PositionCurseur > MaxNotes THEN PositionCurseur = MaxNotes
		IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
		Draw.Chanels 0

	END IF
END SUB

DEFSNG A-Z
SUB Manage.TrackBar (this AS TrackBar)
	this.ValueChanged = 0
	IF this.Value > this.MInVal THEN
		IF Click.Button(this.DwBtn) THEN
			this.Value = this.Value - (this.StepValue)
			IF this.Value < this.MInVal THEN this.Value = this.MInVal
			Draw.TrackBar this
			this.ValueChanged = -1
		END IF
	END IF
	IF this.Value < this.MaxVal THEN
		IF Click.Button(this.upbtn) THEN
			this.Value = this.Value + (this.StepValue)
			IF this.Value > this.MaxVal THEN this.Value = this.MaxVal
			Draw.TrackBar this
			this.ValueChanged = -1
		END IF
	END IF

END SUB

SUB NewChanel
	     IF NbrChanel >= 8 THEN EXIT SUB
	     NbrChanel = NbrChanel + 1
	     Chanels(NbrChanel).Instrument.attack1 = 15
	     Chanels(NbrChanel).Instrument.attack2 = 15
	     Chanels(NbrChanel).Instrument.decay1 = 1
	     Chanels(NbrChanel).Instrument.decay2 = 2
	     Chanels(NbrChanel).Instrument.sustain1 = 6
	     Chanels(NbrChanel).Instrument.sustain2 = 7
	     Chanels(NbrChanel).Instrument.released1 = 3
	     Chanels(NbrChanel).Instrument.released2 = 2
	     Chanels(NbrChanel).Instrument.outp1 = 3
	     Chanels(NbrChanel).Instrument.outp2 = 0
	     Chanels(NbrChanel).Instrument.amplitudevibrato1 = 0
	     Chanels(NbrChanel).Instrument.amplitudevibrato2 = 0
	     Chanels(NbrChanel).Instrument.scalling1 = 1
	     Chanels(NbrChanel).Instrument.scalling2 = 0
	     Chanels(NbrChanel).Instrument.waveselect1 = 1
	     Chanels(NbrChanel).Instrument.waveselect2 = 1
	     Chanels(NbrChanel).Instrument.pitchvibrato1 = 0
	     Chanels(NbrChanel).Instrument.pitchvibrato2 = 0
	     Chanels(NbrChanel).Instrument.frequencymultipler1 = 1
	     Chanels(NbrChanel).Instrument.frequencymultipler2 = 1
	     Chanels(NbrChanel).Instrument.enveloppescalling1 = 1
	     Chanels(NbrChanel).Instrument.enveloppescalling2 = 0
	     Chanels(NbrChanel).Instrument.sustaininglevel1 = 1
	     Chanels(NbrChanel).Instrument.sustaininglevel2 = 0
	     Chanels(NbrChanel).Instrument.feedback = 2
	     Chanels(NbrChanel).Instrument.connection = 0
	     Chanels(NbrChanel).Instrument.iname = ""
	     FOR i = 0 TO MaxNotes
		Notes(NbrChanel, i).num = -2
		Notes(NbrChanel, i).Octave = 1
	     NEXT i
	     Chanels(NbrChanel).Enabled = -1
	     setinstrument NbrChanel, Chanels(NbrChanel).Instrument

END SUB

SUB NewFile
	NbrChanel = 0
	FOR i = 1 TO 8
		NewChanel
	NEXT i
	SelectedOctave = 3
	IsDiese = 0
	LastNote = 0
	PositionCurseur = 0
	SelectedChanel = 1
	FIleHeader.Tempo = 60
END SUB

FUNCTION OpenFile (filename$)
       
	fic = FREEFILE
	OpenFile = 0
	DIM TmpHeader AS MusicHeader
	OPEN filename$ FOR BINARY AS fic
	      GET #fic, , TmpHeader
	       IF TmpHeader.Format <> "#FMX" THEN
		  Alert ("Incorrect File Format")
		  CLOSE fic
		  EXIT FUNCTION
	       END IF
		NewFile
		FIleHeader = TmpHeader
		NbrChanel = FIleHeader.ChanelCount
		LastNote = FIleHeader.NbrNotes
		FOR i = 1 TO NbrChanel
			 GET #fic, , Chanels(i)
		NEXT i
		FOR i = 1 TO NbrChanel
		FOR j = 0 TO LastNote
			GET #fic, , Notes(i, j)
		NEXT j
	      NEXT i
	CLOSE fic
       
	SelectedOctave = 3
	IsDiese = 0
	LastNote = 0
	PositionCurseur = 0
	SelectedChanel = 1
       
	FOR i% = 1 TO NbrChanel
	     setinstrument i%, Chanels(i%).Instrument
	NEXT i%
	OpenFile = -1
END FUNCTION

DEFINT A-Z
SUB PlayAll
PlayBtn.text = txtCtrlStop
Draw.Button PlayBtn
GetLastNote
DIM OldNum(1 TO 8) AS INTEGER
DIM OldOctave(1 TO 8) AS INTEGER
replay:
	FOR i = PositionCurseur TO LastNote
	     
		FOR j = 1 TO NbrChanel
			Draw.Chanel j, 0
			IF Chanels(j).Enabled THEN
				PlayNote j, Notes(j, i).num, Notes(j, i).Octave
				IF Notes(j, i).num <> -2 THEN
					IF i > -2 THEN
						Draw.KeyBoardNote OldNum(j), OldOctave(j), -1
					END IF
					IF i > -1 THEN
					Draw.KeyBoardNote Notes(j, i).num, Notes(j, i).Octave, j
					OldNum(j) = Notes(j, i).num
					OldOctave(j) = Notes(j, i).Octave

					END IF
				END IF
			END IF
		NEXT
		PositionCurseur = PositionCurseur + 1
		t! = TIMER
		sec! = 60 / ((FIleHeader.Tempo) * 4)
		DO

			c$ = INKEY$
			IF LCASE$(c$) = "s" OR c$ = CHR$(27) OR Click.Button(PlayBtn) THEN
			      PlayBtn.text = txtCtrlPlay
			      Draw.Button PlayBtn
				FOR l = 1 TO NbrChanel
					Draw.Chanel l, 0
				NEXT l

				r! = TIMER: DO: LOOP UNTIL TIMER - r! > .25
				StopAllChanels
				Draw.KeyBOard
				EXIT SUB
			END IF

			'les F1  F8 pour eteindre un channel
			FOR kk = 1 TO 8
			IF c$ = CHR$(0) + CHR$(58 + k) THEN Chanels(kk).Enabled = NOT Chanels(kk).Enabled
			NEXT kk

	LOOP UNTIL TIMER > t! + sec!

	NEXT
	PositionCurseur = 0
	
GOTO replay


END SUB

SUB PlayNote (chan, note, Octave)
IF note = -2 THEN EXIT SUB

writereg &HA0 + chan - 1, 0
writereg &HB0 + chan - 1, 0
IF note = -1 THEN ResetChan chan: EXIT SUB

freq% = notef(note MOD 12)
writereg &HA0 + chan - 1, freq% AND &HFF
writereg &HB0 + chan - 1, INT(freq% / 256) OR 32 OR (Octave * 4)
END SUB

DEFSNG A-Z
SUB Record
	RecordBtn.text = txtCtrlStop
	Draw.Button RecordBtn

	Recording = -1
	n = Notes(SelectedChanel, PositonCurseur).num
	DO:
		Manage.Keyboard
		a$ = INKEY$
		IF a$ = CHR$(27) THEN GOTO finrecord
		IF Click.Button(RecordBtn) THEN GOTO finrecord
	LOOP UNTIL Notes(SelectedChanel, PositonCurseur).num <> n
	t! = TIMER
	interval! = 1 / (60 / FIleHeader.Tempo)
	DO
	  Manage.Keyboard
	  IF TIMER > t! + interval! THEN
			GetLastNote
			PositionCurseur = PositionCurseur + 1
			IF LastNote < PositionCurseur THEN LastNote = PositionCurseur
			Draw.Chanels 0
	  t! = TIMER
	  END IF
	LOOP UNTIL INKEY$ = CHR$(27) OR Click.Button(RecordBtn)
finrecord:
	Recording = 0
	RecordBtn.text = txtCtrlRecord
	Draw.Button RecordBtn
END SUB

SUB ResetChan (chan AS INTEGER)
	writereg &HA0 + chan - 1, 0
	writereg &HB0 + chan - 1, 0
END SUB

DEFINT A-Z
SUB Save.InsEdit (num)
	 Chanels(num).Instrument.attack1 = AtackTrack(1).Value
	 Chanels(num).Instrument.attack2 = AtackTrack(2).Value
	 Chanels(num).Instrument.decay1 = DecayTrack(1).Value
	 Chanels(num).Instrument.decay2 = DecayTrack(2).Value
	 Chanels(num).Instrument.sustain1 = SustainTrack(1).Value
	 Chanels(num).Instrument.sustain2 = SustainTrack(2).Value
	 Chanels(num).Instrument.released1 = ReleaseTrack(1).Value
	 Chanels(num).Instrument.released2 = ReleaseTrack(2).Value
	 Chanels(num).Instrument.outp1 = OutLevelTrack(1).Value
	 Chanels(num).Instrument.outp2 = OutLevelTrack(2).Value
	 Chanels(num).Instrument.scalling1 = LevelScall(1).Value
	 Chanels(num).Instrument.scalling2 = LevelScall(2).Value
	 Chanels(num).Instrument.frequencymultipler1 = FreqMult(1).Value
	 Chanels(num).Instrument.frequencymultipler2 = FreqMult(2).Value
	Chanels(num).Instrument.amplitudevibrato1 = ABS(VibratoAmp(1).selected)
	Chanels(num).Instrument.amplitudevibrato2 = ABS(VibratoAmp(2).selected)
	Chanels(num).Instrument.pitchvibrato1 = ABS(VibratoPitch(1).selected)
	Chanels(num).Instrument.pitchvibrato2 = ABS(VibratoPitch(2).selected)
	Chanels(num).Instrument.scalling1 = ABS(scalling(1).selected)
	Chanels(num).Instrument.scalling2 = ABS(scalling(2).selected)
	Chanels(num).Instrument.sustaininglevel1 = ABS(sustain(1).selected)
	Chanels(num).Instrument.sustaininglevel2 = ABS(sustain(2).selected)
	Chanels(num).Instrument.waveselect1 = WaveSelectList(1).SelectedIndex
	Chanels(num).Instrument.waveselect2 = WaveSelectList(2).SelectedIndex
	Chanels(num).Instrument.feedback = feedback.Value
	Chanels(num).Instrument.connection = ABS(connection(1).selected)
	setinstrument num, Chanels(num).Instrument
	t! = TIMER
	PlayNote num, 9, 4
	DO: LOOP UNTIL TIMER > t! + 1
	ResetChan num
END SUB

DEFSNG A-Z
SUB SaveFile (filename$)
	fic = FREEFILE
	OPEN filename$ FOR BINARY AS fic
	CLOSE fic
	KILL filename$
	GetLastNote
	FIleHeader.Format = "#FMX"
	FIleHeader.NbrNotes = LastNote
	FIleHeader.ChanelCount = NbrChanel
	OPEN filename$ FOR BINARY AS fic
	      PUT #fic, , FIleHeader
	      FOR i = 1 TO NbrChanel
			 PUT #fic, , Chanels(i)
	      NEXT i
	      FOR i = 1 TO NbrChanel
		FOR j = 0 TO LastNote
			PUT #fic, , Notes(i, j)
		NEXT j
	      NEXT i
	CLOSE fic
END SUB

DEFINT A-Z
SUB setinstrument (channel AS INTEGER, ins AS Instrument)

SELECT CASE channel%
	CASE IS = 1:
		carplus = 0
		modplus = 3
	CASE 2:
		carplus = 1
		modplus = 4
     
	CASE 3:
		carplus = 2
		modplus = &H5
     
	CASE 4:
		carplus = 8
		modplus = &HB
     
	CASE 5:
		carplus = 9
		modplus = &HC
     
	CASE 6:
		carplus = 10
		modplus = &HD
     
	CASE 7:
		carplus = &H10
		modplus = &H13
     
	CASE 8:
		carplus = &H11
		modplus = &H14
     
	CASE 9:
		carplus = &H12
		modplus = &H15

END SELECT


r1 = &H20 + carplus       'le carrier
r2 = &H20 + modplus
r3 = &H40 + carplus
r4 = &H40 + modplus
r5 = &H60 + carplus
r6 = &H60 + modplus
r7 = &H80 + carplus
r8 = &H80 + modplus

r9 = 224 + carplus
r10 = 227 + carplus
r11 = 192 + chan - 1

'-------LA VAR 1
IF ins.pitchvibrato1 = 1 THEN var1 = 128
IF ins.amplitudevibrato1 = 1 THEN var1 = var1 + 64
IF ins.sustaininglevel1 = 1 THEN var1 = var1 + 32
IF ins.enveloppescalling1 = 1 THEN var1 = var1 + 16
var1 = var1 + ins.frequencymultipler1

'-------LA VAR 2
IF ins.pitchvibrato2 = 1 THEN var2 = 128
IF ins.amplitudevibrato2 = 1 THEN var2 = var2 + 64
IF ins.sustaininglevel2 = 1 THEN var2 = var2 + 32
IF insenveloppescalling2 = 1 THEN var2 = var2 + 16
var2 = var2 + ins.frequencymultipler2

'-------LA VAR 3
var3 = (ins.scalling1 * 64) + ins.outp1

'-------LA VAR 4
var4 = (ins.scalling2 * 64) + ins.outp2

'------- La var 5
var5 = (ins.attack1 * 16) + ins.decay1

'------- La var 5
var6 = (ins.attack2 * 16) + ins.decay2

'--------La var 7
var7 = (ins.sustain1 * 16) + ins.released1

'--------La var 8
var8 = (ins.sustain2 * 16) + ins.released2

'--------La var 9
var9 = ins.waveselect1

'--------La var 10
var10 = ins.waveselect2

'--------La var 11
var11 = (ins.feedback * 2) + ins.connection

writereg r1, var1
writereg r2, var2
writereg r3, var3
writereg r4, var4
writereg r5, var5

writereg r6, var6
writereg r7, var7

writereg r8, var8

writereg r9, var9
writereg r10, var10
writereg r11, var11


END SUB

SUB ShowGraph
	gx = 550
	gy = 100
	gx1 = (640 - gx) \ 2
	gy1 = (480 - gy) \ 2
	gy2 = gy1 + gy
	gx2 = gx1 + gx
	SaveScreen "fmgraph"
	MouseHide
		Draw.Window gx1, gy1, gx2, gy2, txtGraphTitle
		LINE (gx1 + 4, gy1 + 19)-(gx2 - 4, gy2 - 4), 15, BF
		GetLastNote
		FOR i = 1 TO NbrChanel
			first = -1
			FOR x = 1 TO LastNote
				f = -(Notes(i, x).num + Notes(i, x).Octave * 12)
				IF Notes(i, x).num = -1 THEN f = 0
				IF Notes(i, x).num <> -2 THEN
				   ypos = (gy2 - 10) + f
				ELSE
				  IF first THEN
				    ypos = (gy2 - 10)
				  ELSE
				    ypos = ypos
				  END IF

				END IF
				xpos = gx1 + 10 + (x - 1) * ((gx - 20) / LastNote)
			       
				IF first THEN
					LINE (xpos, ypos)-(xpos, ypos), i
					LINE (xpos, ypos + 1)-(xpos, ypos + 1), i
				ELSE
					LINE (ox, oy)-(xpos, ypos), i
					LINE (ox, oy + 1)-(xpos, ypos + 1), i
				END IF
				ox = xpos: oy = ypos
				ox = xpos: oy = ypos
				first = 0
			NEXT x
		NEXT i
	MouseShow

	DO:
	LOOP UNTIL INKEY$ = CHR$(27)
	RestoreScreen "fmgraph"
END SUB

DEFSNG A-Z
SUB Start.InsEdit (num AS INTEGER)
'DIM VibratoPitch(1 TO 2) AS ListItem
'DIM VibratoPitchList AS ItemList


VibratoAmp(1).text = txtInsEnabled
VibratoAmp(2).text = txtInsEnabled
VibratoPitch(1).text = txtInsEnabled
VibratoPitch(2).text = txtInsEnabled
scalling(1).text = txtInsEnabled
scalling(2).text = txtInsEnabled
sustain(1).text = txtInsEnabled
sustain(2).text = txtInsEnabled
connection(1).text = txtInsEnabled

FOR i = 0 TO 3
	waveselect1(i).text = LTRIM$(RTRIM$(STR$(i)))
	waveselect2(i).text = LTRIM$(RTRIM$(STR$(i)))
NEXT i


	x = 520
	y = 345
	ix1 = (640 - x) \ 2
	ix2 = ix1 + x
	iy1 = (480 - y) \ 2
	iy2 = y1 + y
	
	Initx.Button CloseBtn, txtInsClose, ix2 - 50, iy2 - 25, ix2 - 5, iy2 - 5
	Initx.Button FmiBtn, txtInsImportfmi, ix1 + 5, iy2 - 25, ix1 + 100, iy2 - 5
	Init.TrackBar AtackTrack(1), 0, 15, ix1 + 200, iy1 + 17
	Init.TrackBar AtackTrack(2), 0, 15, ix1 + 400, iy1 + 17
	Init.TrackBar DecayTrack(1), 0, 15, ix1 + 200, iy1 + 32
	Init.TrackBar DecayTrack(2), 0, 15, ix1 + 400, iy1 + 32
	Init.TrackBar SustainTrack(1), 0, 15, ix1 + 200, iy1 + 47
	Init.TrackBar SustainTrack(2), 0, 15, ix1 + 400, iy1 + 47
	Init.TrackBar ReleaseTrack(1), 0, 15, ix1 + 200, iy1 + 62
	Init.TrackBar ReleaseTrack(2), 0, 15, ix1 + 400, iy1 + 62
	Init.TrackBar OutLevelTrack(1), 0, 15, ix1 + 200, iy1 + 77
	Init.TrackBar OutLevelTrack(2), 0, 15, ix1 + 400, iy1 + 77
	Init.TrackBar LevelScall(1), 0, 3, ix1 + 200, iy1 + 92
	Init.TrackBar LevelScall(2), 0, 3, ix1 + 400, iy1 + 92
	Init.TrackBar FreqMult(1), 0, 15, ix1 + 200, iy1 + 137
	Init.TrackBar FreqMult(2), 0, 15, ix1 + 400, iy1 + 137
	Init.ItemLIst VibratoAmpList, ix1 + 190, iy1 + 110, 2, 1
	Init.ItemLIst VibratoPitchList, ix1 + 190, iy1 + 125, 2, 1
	Init.ItemLIst ScallingList, ix1 + 190, iy1 + 154, 2, 1
	Init.ItemLIst SustainList, ix1 + 190, iy1 + 170, 2, 1
	Init.ItemLIst WaveSelectList(1), ix1 + 190, iy1 + 185, 4, 1
	Init.ItemLIst WaveSelectList(2), ix1 + 390, iy1 + 185, 4, 1
	Init.TrackBar feedback, 1, 8, ix1 + 120, iy1 + 208
	Init.ItemLIst ConnectionList, ix1 + 110, iy1 + 225, 1, 2
	VibratoAmpList.MinWidth = 25
	VibratoAmpList.MaxWidth = 25
	VibratoPitchList.MinWidth = 25
	VibratoPitchList.MaxWidth = 25
	ScallingList.MinWidth = 25
	ScallingList.MaxWidth = 25
	SustainList.MinWidth = 25
	SustainList.MaxWidth = 25
	WaveSelectList(1).MinWidth = 3
	WaveSelectList(2).MinWidth = 3
	WaveSelectList(1).MaxWidth = 3
	WaveSelectList(2).MaxWidth = 3
       
	Load.InsEdit num
	SaveScreen ("insedit")
	Draw.InsEdit
	DO
		IF Click.Button(FmiBtn) THEN
			ImportFmi Chanels(num).Instrument
			Load.InsEdit num
			Draw.InsEdit
		END IF

		Manage.TrackBar AtackTrack(1)
		Manage.TrackBar AtackTrack(2)
		Manage.TrackBar DecayTrack(1)
		Manage.TrackBar DecayTrack(2)
		Manage.TrackBar SustainTrack(1)
		Manage.TrackBar SustainTrack(2)
		Manage.TrackBar ReleaseTrack(1)
		Manage.TrackBar ReleaseTrack(2)
		Manage.TrackBar feedback
		Manage.TrackBar OutLevelTrack(1)
		Manage.TrackBar OutLevelTrack(2)
		Manage.TrackBar LevelScall(1)
		Manage.TrackBar LevelScall(2)
		
      
		Manage.TrackBar FreqMult(1)
		Manage.TrackBar FreqMult(2)

		Manage.CheckBoxList VibratoAmpList, VibratoAmp()
		Manage.CheckBoxList VibratoPitchList, VibratoPitch()
		Manage.CheckBoxList ScallingList, scalling()
		Manage.CheckBoxList SustainList, sustain()
		Manage.RadioBUttonList WaveSelectList(1), waveselect1()
		Manage.RadioBUttonList WaveSelectList(2), waveselect2()
		Manage.CheckBoxList ConnectionList, connection()
       

	LOOP UNTIL Click.Button(CloseBtn)

	RestoreScreen ("insedit")
	Save.InsEdit num
	Shelf.Load
	Shelf.Draw
END SUB

SUB StopAllChanels
	FOR i% = 1 TO NbrChanel
		ResetChan i%
	NEXT i%
END SUB

SUB writereg (reg%, info%)
 OUT &H388, reg%
 FOR d% = 1 TO 6: x% = INP(&H388): NEXT d%
 OUT &H389, info%
 FOR d% = 1 TO 35: x% = INP(&H388): NEXT d%
END SUB

