DECLARE FUNCTION GetOpt$ (akey AS STRING)
DECLARE FUNCTION FindOpt! (myoption AS STRING)

'$INCLUDE: 'lib\pkglib.bi'
'$INCLUDE: 'srcs\pkgutil.str'

CLS
IF FindOpt("-L") THEN GOSUB getList
IF FindOpt("-C") THEN GOSUB Create
IF FindOpt("-A") THEN GOSUB AddFile
IF FindOpt("-E") THEN GOSUB ExtractFile
IF FindOpt("-D") THEN GOSUB SaveDir
IF FindOpt("-X") THEN GOSUB ExtractAll
IF FindOpt("-R") THEN GOSUB Remove
help:
	PRINT txtTitle
        PRINT
	PRINT txt0
	PRINT txt1
	PRINT txt2
	PRINT txt3
	PRINT txt4
	PRINT txt5
	PRINT txt6
	PRINT txt7
	PRINT txt8
	PRINT txt9
	PRINT txt10
	PRINT txt11
	PRINT txt12
	PRINT txt13
	PRINT txt14
	PRINT txt15
	PRINT txt16
	PRINT txt17
	PRINT txt18
	PRINT txt19
	PRINT txt20
	PRINT txt21
	PRINT txt22
	PRINT txt23
	PRINT txt24
	PRINT txt25
	PRINT txt26
	PRINT txt27
	PRINT txt28
	PRINT txt29

END

getList:
	a$ = GetOpt$("archive")
	IF a$ = "" THEN GOSUB help
	Archive.List a$
       
END

AddFile:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	FileName$ = GetOpt$("file")
	IF FileName$ = "" THEN GOSUB help
	Method% = VAL(GetOpt$("method"))
	Archive.Add Archive$, FileName$, "", Method%
END

Create:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	Archive.Create Archive$
RETURN

ExtractFile:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	FileName$ = GetOpt$("file")
	IF FileName$ = "" THEN GOSUB help
	number% = VAL(GetOpt$("num"))
	IF number% = 0 THEN GOSUB help
	Archive.Extract Archive$, number%, FileName$

END

SaveDir:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	directory$ = GetOpt$("directory")
	IF directory$ = "" THEN GOSUB help
	Archive.ArchiveDirectory directory$, Archive$
END

ExtractAll:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	directory$ = GetOpt$("directory")
	IF directory$ = "" THEN
		SHELL "cd>dir.tmp"
		OPEN "dir.tmp" FOR INPUT AS 1
			INPUT #1, directory$
		CLOSE 1
		KILL "dir.tmp"
	END IF
	Archive.ExtractAll Archive$, directory$

END

Remove:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	number% = VAL(GetOpt$("num"))
	IF number% = 0 THEN GOSUB help
	Archive.Remove Archive$, number%

END

FUNCTION FindOpt (myoption AS STRING)
	   FOR i = 1 TO LEN(COMMAND$) - (LEN(myoption) - 1)
		IF MID$(COMMAND$, i, LEN(myoption)) = myoption THEN
			IF i = 1 THEN FindOpt = -1: EXIT FUNCTION
			IF MID$(COMMAND$, i - 1, 1) = " " THEN FindOpt = -1: EXIT FUNCTION
		END IF
	   NEXT i
END FUNCTION

FUNCTION GetOpt$ (akey AS STRING)
	t$ = ""
	i = INSTR(UCASE$(COMMAND$), UCASE$(akey) + "=")
	IF (i > 0) AND (i + LEN(akey)) < LEN(COMMAND$) THEN
	  t$ = MID$(COMMAND$, i + LEN(akey) + 1)
	  IF LEFT$(t$, 1) = CHR$(34) THEN
		FOR i = 2 TO LEN(t$)
		  IF MID$(t$, i, 1) = CHR$(34) THEN
			t$ = MID$(LEFT$(t$, i - 1), 2)
			EXIT FOR
		  END IF
		NEXT i
	  ELSE
		  FOR i = 1 TO LEN(t$)
			IF MID$(t$, i, 1) = " " THEN
			  t$ = LEFT$(t$, i - 1)
			  EXIT FOR
			END IF
		  NEXT i
	  END IF
	END IF
	GetOpt$ = UCASE$(t$)

END FUNCTION

