DECLARE SUB SaveFile (filename AS STRING, txt AS STRING)
DECLARE SUB OpenFile (filename AS STRING, text AS STRING)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\xTextBox.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\shelf.bi'
'$INCLUDE: 'srcs\tinypad.str'
DIM SHARED extensions(10) AS STRING * 4
extensions(1) = ".txt"
extensions(2) = ".inf"
extensions(3) = ".bat"
extensions(4) = ".bas"
extensions(5) = ".mak"
extensions(6) = ".log"
extensions(7) = ".xml"
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
wx = 611
wy = 395
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuNew)
App.AddMenuItem (txtMenuOpen)
App.AddMenuItem (txtMenuSave)
App.AddMenuItem (txtMenuSaveas)
IF VAL(RegRead("Network:Enabled")) = 1 THEN
SessionID$ = RegRead("Live:SessionID")
IF SessionID$ <> "" THEN
       App.AddMenuItem (txtMenuLiveopen)
       App.AddMenuItem (txtMenuLivesave)
END IF
END IF

App.AddMenuItem (txtMenuExit)
Shelf.Load
GUI.Init
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, txtTitle
DIM mytext AS STRING
DIM txt AS MultiLine
Init.MultiLine txt, wx1 + 3, wy1 + 2, (wx - 21) \ 8, (wy - 6) \ 8
OpenedFIle$ = ""



Draw.MUltiLIne txt, mytext
Shelf.Draw
MouseShow
DO
'        IF FreeMem& <> FRE("") THEN
'                FreeMem& = FRE("")
'                Draw.Text "Free mem: " + STR$(FreeMem&) + " B ", 70, 5, 15, 20
'        END IF
	oldfocus = txt.focus
	SelectedMenu = ""
	App.Manage
	Manage.MultiLIne txt, mytext
	SELECT CASE SelectedMenu
		CASE txtMenuExit:
			app.Exit
		CASE txtMenuNew:
			mytext = ""
			Draw.MUltiLIne txt, mytext
			OpenedFIle$ = ""
		CASE txtMenuOpen:
			GOSUB OpenSUb
		CASE txtMenuSave:
			GOSUB SaveSub
		CASE txtMenuSaveas:
			GOSUB SaveAsSub
		CASE txtMenuLiveopen
			mytext = ""
			fichier$ = NetFileSelect("open")
			IF fichier$ <> "" THEN
			   OpenFile "outdoc.tmp", mytext
			   KILL "outdoc.tmp"
			   Draw.MUltiLIne txt, mytext
			   OpenedFIle$ = ""
			END IF
		CASE txtMenuLivesave
			SaveFile "indoc.tmp", mytext
			fichier$ = NetFileSelect("save")
			OpenedFIle$ = ""
			
       
	END SELECT
	IF Shelf.Drag THEN
	       GOSUB OpenDragSUb
	END IF
LOOP


OpenDragSUb:
	mytext = ""
	fichier$ = Shelf.Selected$
	ok = 0
	FOR i = 1 TO 10
		IF LCASE$(RIGHT$(fichier$, 4)) = extensions(i) THEN ok = -1
	NEXT i

	IF NOT ok THEN RETURN

	OpenFile fichier$, mytext
	OpenedFIle$ = fichier$
	Draw.MUltiLIne txt, mytext
RETURN

OpenSUb:
	mytext = ""
	fichier$ = FileSelect("open", "", "* document=yes")
	IF fichier$ <> "" THEN
		OpenFile "outdoc.tmp", mytext
		KILL "outdoc.tmp"
		OpenedFIle$ = fichier$
		Draw.MUltiLIne txt, mytext
	END IF
	Shelf.Load
	Shelf.Draw
RETURN

SaveSub:
	IF OpenedFIle$ = "" THEN GOTO SaveAsSub
	SaveFile OpenedFIle$, mytext
RETURN

SaveAsSub:
	SaveFile "indoc.tmp", mytext
	fichier$ = FileSelect("save", "", "* document=yes")
	IF fichier$ <> "" THEN OpenedFIle$ = fichier$
	Shelf.Load
	Shelf.Draw
RETURN

SUB OpenFile (filename AS STRING, text AS STRING)

	fic = FREEFILE
	text = ""
	OPEN filename FOR BINARY AS fic
		d& = LOF(fic)
		IF d& > maxdata THEN d& = maxdata
		text = STRING$(d&, " ")
		GET #fic, , text
	CLOSE fic
END SUB

SUB SaveFile (filename AS STRING, txt AS STRING)
	fic = FREEFILE
	OPEN filename FOR BINARY AS fic
	CLOSE fic
	KILL filename
	OPEN filename FOR BINARY AS fic
		PUT #fic, , txt
	CLOSE fic
END SUB

