DECLARE SUB Draw.Xpm (fichier AS STRING, xpos AS INTEGER, ypos AS INTEGER)
DECLARE FUNCTION DragDrop% (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, newx AS INTEGER, newy AS INTEGER, Text AS STRING)
DECLARE SUB Progress (Text AS STRING, value AS LONG, maximum AS LONG)
DECLARE SUB ScreenCapture (akey AS STRING)
DECLARE SUB Save.Bmp (bmpfile AS STRING)
DECLARE SUB Draw.Window (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, title AS STRING)
'*** Button Handler ***
DECLARE SUB Initx.Button (this AS ANY, t AS STRING, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER)
DECLARE SUB Init.Button (this AS ANY, t AS STRING, x AS INTEGER, y AS INTEGER)
DECLARE SUB Draw.Button (button AS ANY)
DECLARE FUNCTION Click.Button! (this AS ANY)


'*** Graphics functions
DECLARE SUB GUI.Init ()
DECLARE SUB cls.screen (col AS INTEGER)
DECLARE SUB draw.Gradient (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, c1 AS INTEGER, c2 AS INTEGER)
DECLARE SUB Alpha (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, i AS INTEGER)
DECLARE SUB load.bsv (image AS STRING)
DECLARE SUB Load.BMP (bmpfile AS STRING, x1 AS INTEGER, y1 AS INTEGER)
DECLARE SUB Draw.Pic (picfile AS STRING, x1 AS INTEGER, y1 AS INTEGER, z1 AS SINGLE)
DECLARE SUB Draw.Pic2 (imgfile AS STRING, cx1 AS INTEGER, cy1 AS INTEGER, cx2 AS INTEGER, cy2 AS INTEGER, x1 AS INTEGER, y1 AS INTEGER)
DECLARE SUB Draw.Frame (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER)

DECLARE FUNCTION opt$ (akey AS STRING)
DECLARE SUB setvar (inifile AS STRING, variable AS STRING, valeur AS STRING)
DECLARE FUNCTION getvar$ (inifile AS STRING, nomdevariable AS STRING)

'*** Font Handler ***
DECLARE SUB load.font (fontfile AS STRING)
DECLARE SUB Draw.Text (Texte AS STRING, x1 AS INTEGER, y1 AS INTEGER, fcolor AS INTEGER, bcolor AS INTEGER)

DECLARE FUNCTION CurrentDir$ ()
DIM SHARED fontdata(0 TO 255, 0 TO 7) AS STRING * 1
TYPE BMPHeaderType
	id AS STRING * 2        'Should be "BM"
	size AS LONG            'Size of the data
	rr1 AS INTEGER
	rr2 AS INTEGER '
	offset AS LONG          'Position of start of pixel data
	horz AS LONG            '
	wid AS LONG             'Image width
	hei AS LONG             'Image height
	planes AS INTEGER       '
	bpp AS INTEGER  'Should read 8 for a 256 colour image
	pakbyte AS LONG '
	imagebytes AS LONG      'Width*Height
	xres AS LONG            '
	yres AS LONG            '
	colch AS LONG           '
	ic AS LONG              '
	pal AS STRING * 1024    'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
END TYPE

TYPE button
	x1 AS INTEGER
	y1 AS INTEGER
	x2 AS INTEGER
	y2 AS INTEGER
	Text AS STRING * 30
	hover AS INTEGER
	pressed AS INTEGER
	style AS INTEGER
END TYPE



COMMON SHARED xres AS INTEGER
COMMON SHARED yres AS INTEGER
COMMON SHARED SHelfColor  AS INTEGER
COMMON SHARED BgColor AS INTEGER
COMMON SHARED BorderColor1 AS INTEGER
COMMON SHARED BorderColor2 AS INTEGER
COMMON SHARED TextColor AS INTEGER
COMMON SHARED SelectBgColor AS INTEGER
COMMON SHARED SelectTextColor AS INTEGER

